/*
 *	EXAM5.C
 *
 *	Super-stupid multi-Transputer prime number solver as described in the
 *	"EXAMPLES" section of the Logical Systems "TRANSPUTER 'C' LIBRARY
 *	DESCRIPTION" documentation.  The "pipe4.nif" file contains a suitable
 *	topology file for use with LD-NET when running this program on four
 *	Transputers.
 */

#include	<stdio.h>
#include	<conc.h>

#define		MAX_PRIME	10000	/* Largest # to test for primality */
#define		NUM_NODES	4	/* # of Transputer nodes */
#define		INCR		(NUM_NODES * 2)	/* Prime interval */

main()
	{
	Channel			*chan;
	unsigned	int	child_data = 0;
	unsigned	int	i,j;
	unsigned	int	num_primes = 0;
/*
 *	Check 1/N of the numbers for primality, where N
 *	is the number of Transputer nodes.
 */
	for(i = (_node_number * 2) + 1; i < MAX_PRIME; i+= INCR)
		{
		for(j = 3; j < i; j++)
			{
			if((i % j) == 0)
				break;
			}
		if(j >= i)
			num_primes++;
		}
/*
 *	Report results back either to user or parent node.
 */
	if(_node_number == 1)		/* Root node */
		{
		num_primes++;		/* Acct for 2 being prime */
		for(i = 1; i < NUM_NODES; i++)
			{
			chan = LINK0IN + ((int) ProcAlt(LINK0IN,LINK1IN,
				LINK2IN,LINK3IN,0));
			ChanIn(chan,(char *) &child_data,2);
			num_primes += child_data;
			}
		printf("%u primes less than %u found\n",num_primes,MAX_PRIME);
		}
	else				/* Non-root node */
		{
		ChanOut(_boot_chan_out,(char *) &num_primes,2);
		while(1)
			{
			chan = LINK0IN + ((int) ProcAlt(LINK0IN,LINK1IN,
				LINK2IN,LINK3IN,0));
			ChanIn(chan,(char *) &child_data,2);
			ChanOut(_boot_chan_out,(char *) &child_data,2);
			}
		}
	}
