/*
 *	math.h
 *
 *	Copyright 1987-1988 by Logical Systems.
 */

#ifndef	_MATH				/* Avoid duplication */
#define	_MATH		1

#ifndef	volatile
#define	volatile			/* Not implemented yet */
#define	const				/* Not implemented yet */
#endif	/* volatile */

#define	EDOM		1		/* Domain error */
#define	ERANGE		2		/* Range error */

#ifdef	DOUBLE32			/* If double is 32 bits long */
#define	HUGE_VAL	3.40282347E+38	/* "max" double value */

#ifndef	HUGE
#define	HUGE		3.40282347E+38	/* "max" double value */
#endif	/* HUGE */
#else	/* DOUBLE32 */

/*
 *	Value for LSD of HUGE_VAL/VAL should be "6" instead of "5" but some
 *	host system "C" compilers treat this incorrectly as a NaN.
 */
#define	HUGE_VAL	1.797693134862315E+308	/* "max" double value */

#ifndef	HUGE
#define	HUGE		1.797693134862315E+308	/* "max" double value */
#endif	/* HUGE */
#endif	/* DOUBLE32 */

typedef	struct			/* Double precision COMPLEX number type */
	{
	double	real;		/* Real part of complex number */
	double	imag;		/* Imaginary part of complex number */
	} COMPLEX;
typedef	struct			/* Single precision COMPLEX number type */
	{
	float	real;		/* Real part of complex number */
	float	imag;		/* Imaginary part of complex number */
	} COMPLEXF;

double	acos(double x);
double	asin(double x);
double	atan(double x);
double	atan2(double y, double x);
double	cabs(COMPLEX x);
double	ceil(double x);
double	cos(double x);
double	cosh(double x);
double	exp(double x);
double	fabs(double x);
double	_BUILTIN_fabs(double x);
#define	fabs(x)		_BUILTIN_fabs(x)
void	fft(COMPLEX x[], int y);
double	floor(double x);
double	fmod(double x, double y);
double	frexp(double value, int *exp);
double	hypot(double x, double y);
void	ifft(COMPLEX x[], int y);
double	ldexp(double x, int exp);
double	log(double x);
double	log10(double x);
double	modf(double value, double *iptr);
double	pow(double x, double y);
double	sin(double x);
double	sinh(double x);
double	sqrt(double x);
double	_BUILTIN_sqrt(double x);
#define	sqrt(x)		_BUILTIN_sqrt(x)
double	tan(double x);
double	tanh(double x);

float	acosf(float x);
float	asinf(float x);
float	atanf(float x);
float	atan2f(float y, float x);
float	cabsf(COMPLEXF x);
float	ceilf(float x);
float	cosf(float x);
float	coshf(float x);
float	expf(float x);
float	fabsf(float x);
float	_BUILTIN_fabsf(float x);
#define	fabsf(x)	_BUILTIN_fabsf(x)
void	fftf(COMPLEXF x[], int y);
float	floorf(float x);
float	fmodf(float x, float y);
float	frexpf(float value, int *exp);
float	hypotf(float x, float y);
void	ifftf(COMPLEXF x[], int y);
float	ldexpf(float x, int exp);
float	logf(float x);
float	log10f(float x);
float	modff(float value, float *iptr);
float	powf(float x, float y);
float	sinf(float x);
float	sinhf(float x);
float	sqrtf(float x);
float	_BUILTIN_sqrtf(float x);
#define	sqrtf(x)	_BUILTIN_sqrtf(x)
float	tanf(float x);
float	tanhf(float x);

#endif	/* _MATH */
