/*
 *	stdio.h
 *
 *	Copyright 1987 by Logical Systems.
 */

#ifndef	_STDIO				/* Avoid duplication */
#define	_STDIO		1

#ifndef	volatile
#define	volatile			/* Not implemented yet */
#define	const				/* Not implemented yet */
#endif	/* volatile */

typedef	int		FILE;
typedef	unsigned int	fpos_t;
typedef	unsigned int	size_t;
typedef	char	*va_list;

#define	_IOFBF		0		/* Not meaningfull with remote I/O */
#define	_IOLBF		0		/* Not meaningfull with remote I/O */
#define	_IONBF		0		/* Not meaningfull with remote I/O */

#define	BUFSIZ		512
#define	EOF		-1
extern	volatile int	errno;
#define	L_tmpnam	20		/* Host system dependent */
#define	NULL		0
#define	FILENAME_MAX	80		/* Host system dependent */
#define	FOPEN_MAX	20		/* Host system dependent */
#define	OPEN_MAX	20		/* Host system dependent */

#define	SEEK_SET	0
#define	SEEK_CUR	1
#define	SEEK_END	2

#define	TMP_MAX		100		/* Host system dependent */

extern	FILE	_fio[];

#define	stderr		(&_fio[3])
#define	stdin		(&_fio[1])
#define	stdout		(&_fio[2])

void	clearerr(FILE *stream);
int	close(int handle);
int	creat(const char *pathname, int pmode);
int	dup(int handle);
int	dup2(int handle1, int handle2);
int	fclose(FILE *stream);
int	fcloseall(void);
FILE	*fdopen(int handle, const char *mode);
int	feof(FILE *stream);
int	ferror(FILE *stream);
int	fflush(FILE *stream);
int	fgetc(FILE *stream);
/* int	fgetpos(FILE *stream, fpos_t *pos);	*/
char	*fgets(char *s, int n, FILE *stream);
int	fileno(FILE *stream);
FILE	*fopen(const char *pathname, const char *mode);
int	fprintf(FILE *stream, const char *format, ...);
void	_fprintf(FILE *stream, const char *format, ...);
int	fputc(int c, FILE *stream);
int	fputs(const char *s, FILE *stream);
size_t	fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
FILE	*freopen(const char *pathname, const char *mode, FILE *stream);
int	fseek(FILE *stream, long int offset, int origin);
/* int	fsetpos(FILE *stream, const fpos_t *pos);	*/
int	fscanf(FILE *stream, const char *format, ...);
long	ftell(FILE *stream);
size_t	fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
int	getc(FILE *stream);
#define	getc(stream) (fgetc(stream))
int	getch(void);
int	getche(void);
int	getchar(void);
#define	getchar() (fgetc(stdin))
char	*gets(char *s);
int	kbhit(void);
long	lseek(int handle, long int offset, int origin);
int	open(const char *pathname, int oflag, int pmode);
void	perror(const char *s);
int	printf(const char *format, ...);
void	_printf(const char *format, ...);
void	_ns_printf(const char *format, ...);
int	putc(int c, FILE *stream);
#define	putc(c,stream) (fputc((c),(stream)))
int	putchar(int c);
#define	putchar(c) (fputc((c),stdout))
int	puts(const char *s);
int	read(int handle, char *s, size_t count);
int	remove(const char *pathname);
int	rename(const char *old, const char *new);
void	rewind(FILE *stream);
int	scanf(const char *format, ...);
/*void	setbuf(FILE *stream,char *buf);	*Not meaningfull with remote I/O* */
/*int	setvbuf(FILE *stream,char *buf,int mode,size_t size) *Ditto* */
int	sprintf(char *s, const char *format, ...);
int	_sprintf(char *s, const char *format, ...);
int	sscanf(const char *s, const char *format, ...);
FILE	*tmpfile(void);
char	*tmpnam(char *s);
int	ungetc(int c, FILE *stream);
int	unlink(const char *pathname);
int	vfprintf(FILE *stream, const char *format, va_list arg);
int	vprintf(const char *format, va_list arg);
int	vsprintf(char *s, const char *format, va_list arg);
int	write(int handle, char *s, size_t count);

#endif	/* _STDIO */
