/*
 *	string.h
 *
 *	Copyright 1987 by Logical Systems.
 */

#ifndef	_STRING				/* Avoid duplication */
#define	_STRING		1

#ifndef	volatile
#define	volatile			/* Not implemented yet */
#define	const				/* Not implemented yet */
#endif	/* volatile */

#define	EDOM		1		/* Domain error */
#define	ERANGE		2		/* Range error */
#define	SIG_ERR		3		/* Signal error */

#define	NULL		0

typedef	unsigned int	size_t;

int	bcmp(const void *s1, const void *s2, size_t n);
void	*bcopy(void *s1, const void *s2, size_t n);
void	*_BUILTIN_memcpy(void *s1, const void *s2, size_t n);
#define	bcopy(s1,s2,n)	_BUILTIN_memcpy(s2,s1,n)
void	bzero(void *s, size_t n);
char	*index(const char *s, int c);
void	*memccpy(void *s1, const void *s2, int c, size_t n);
void	*memchr(const void *s, int c, size_t n);
int	memcmp(const void *s1, const void *s2, size_t n);
void	*memcpy(void *s1, const void *s2, size_t n);
void	*_BUILTIN_memcpy(void *s1, const void *s2, size_t n);
#define	memcpy(s1,s2,n)	_BUILTIN_memcpy(s1,s2,n)
void	*memmove(void *s1, const void *s2, size_t n);
void	*memset(void *s, int c, size_t n);
char	*rindex(const char *s, int c);
char	*strcat(char *s1, const char *s2);
char	*strchr(const char *s, int c);
int	strcmp(const char *s1, const char *s2);
/* size_t	strcoll(char *to, size_t maxsize, const char *from);	*/
char	*strcpy(char *s1, const char *s2);
#pragma	macro	strcpy(a,b)	/* Speed up copy for constant strings */
#pragma	if	_isstring(b)
	((char *) memcpy((a), b, (size_t)
#pragma	value (_strsize(b))
	))
#pragma	else
	strcpy(a,b)
#pragma	endif
#pragma	endmacro
size_t	strcspn(const char *s1, const char *s2);
char	*strerror(int errnum);
size_t	strlen(const char *s);
#pragma	macro	strlen(a)		/* Eliminate call if constant string */
#pragma	if	_isstring(a)
	((size_t)
#pragma	value ((_strsize(a)) - 1)
	)
#pragma	else
	strlen(a)
#pragma	endif
#pragma	endmacro
char	*strncat(char *s1, const char *s2, size_t n);
int	strncmp(const char *s1, const char *s2, size_t n);
char	*strncpy(char *s1, const char *s2, size_t n);
char	*strpbrk(const char *s1, const char *s2);
char	*strrchr(const char *s, int c);
size_t	strspn(const char *s1, const char *s2);
char	*strstr(const char *s1, const char *s2);
char	*strtok(char *s1, const char *s2);

#endif	/* _STRING */
