/************************************************************************/
/*									*/
/*	File:	atof.c							*/
/*									*/
/*	Contains "atof" and "strtod" routines.				*/
/*									*/
/*	Copyright 1987 by Logical Systems.				*/
/*									*/
/*	Written by Kirk Bailey, last update 12/15/87.			*/
/*									*/
/************************************************************************/

#include	<ctype.h>
#include	<stdlib.h>
#include	<limits.h>

typedef	int		BOOL;
#define	FALSE		0
#define	FOREVER		for(;;)
#define	TRUE		1
typedef	unsigned long	ULONG;

#define	MAXEXP		500		/* Maximum single +/- exponent range */

#ifdef	DEBUG
/* Local to MSC */
#define	ERANGE	1
#define	const	
#define	NULL	0
#ifdef	LATER
#define	ULONG_MAX	((ULONG) 0xFFFFFFFF)	/* (2**32)-1, max ULONG */
#define	INT_MAX		0x7FFF		/* (2**15)-1, max positive integer */
#endif	/* LATER */
union
	{
	ULONG	lnum;
	float	snum;
	double	dnum;
	struct
		{
		ULONG	dlow;
		ULONG	dhigh;
		} llnum;
	} u;


double	atof();
double	xfabs();
char	*xatof();

double	fabs(num)
	double	num;
	{
	if(num < 0.0) return (-num);
	else return(num);
	}

main()
	{
	char	buf[81],*cptr;
	int	length,dp,i;
	long	count;
	double	serr,derr,tfloat1,tfloat2;

	serr = derr = 0.0;
/*
	for(count = 0; ; count++)
		{
		kbhit();
		if((count % 1000) == 0) printf("*");
		length = (rand() % 20) + 1;
		if(rand() % 2) dp = rand() % length;
		else dp = -1;
		for(i = 0; i < length; i++)
			{
			if(i == dp) buf[i] = '.';
			else
				{
				buf[i] = rand_digit();
				}
			}
		if(rand() % 2)
			{
			buf[i++] = 'E';
			if(rand() % 2) buf[i++] = '+';
			else buf[i++] = '-';
			buf[i++] = rand_digit();
			}
		buf[i] = '\0';
		xatof(buf,&u.lnum,FALSE);
		tfloat1 = atof(buf);
		if((tfloat2 = fabs((tfloat1 - u.snum) / tfloat1)) > serr)
			{
			serr = tfloat2;
			printf("Pass #%ld, SINGLE: %s\n",count,buf);
			printf("\tATOF=%g, XATOF=%g, |ERROR| %g\n",
				tfloat1,u.snum,serr);
			}
		xatof(buf,&u.llnum,TRUE);
		if((tfloat2 = fabs((tfloat1 - u.dnum) / tfloat1)) > derr)
			{
			derr = tfloat2;
			printf("Pass #%ld, DOUBLE: %s\n",count,buf);
			printf("\tATOF=%g, XATOF=%g, |ERROR| %g\n",
				tfloat1,u.dnum,derr);
			}
		}
*/
	for(;;)
		{
		gets(buf);
		printf("atof = %.7e,\n",atof(buf));
		errno = 0;
		cptr = xatof(buf,&u.lnum,FALSE);
		printf("Remaining string[%s],errno=%d\n",cptr,errno);
		printf("xatof(single) = %.7e, hex = %.8lX\n",u.snum,u.lnum);
		printf("\natof = %.15e,\n",atof(buf));
		errno = 0;
		cptr = xatof(buf,&u.llnum.dlow,TRUE);
		printf("Remaining string[%s],errno=%d\n",cptr,errno);
	printf("xatof(double) = %.15e, high-hex=%.8lX, low-hex=%.8lX\n",
			u.dnum,u.llnum.dhigh,u.llnum.dlow);
		}
	}

int	rand_digit()
	{
	return ((rand() % 10) + '0');
	}
#endif	/* DEBUG */
/*
 *	Left shift a 64 bit integral value one bit.
 */
static	void
llshift(value)
	ULONG	value[];
	{
	if(value[0] & 0x80000000)
		{
		value[1] = (value[1] << 1) | 1;
		}
	else	value[1] <<= 1;
	value[0] <<= 1;
	}

/*
 *	Right shift a 64 bit integral value one bit.
 */
static	void
lrshift(value)
	ULONG	value[];
	{
	if(value[1] & 1)
		{
		value[0] = (value[0] >> 1) | 0x80000000;
		}
	else	value[0] = (value[0] >> 1) & 0x7FFFFFFF;
	value[1] = (value[1] >> 1) & 0x7FFFFFFF;
	}

/*
 *	Add two 64 bit integral values and replace the first operand with the
 *	result.
 */
static	void
ladd(result,value)
	ULONG	result[],value[];
	{
	ULONG	carry,temp;

	carry = 0;
	temp = result[0] + value[0];

	if(result[0] & 0x80000000)
		{
		if((value[0] & 0x80000000) || ((temp & 0x80000000) == 0))
			carry = 1;
		}
	else
		{
		if((value[0] & 0x80000000) && ((temp & 0x80000000) == 0))
			 carry = 1;
		}
	result[0] = temp;
	result[1] = result[1] + value[1] + carry;
	}

/*
 *	Divide a 64 bit integral value by 5.
 */
static	void
ldiv5(value)
	ULONG	value[];
	{
	register int	shift;
	ULONG	result[2],temp1[2],temp2[2];

	result[0] = 0;			/* Result accumulator */
	result[1] = value[1] / 5;

	temp1[0] = value[0];		/* Dividend for this pass */
	temp1[1] = value[1] % 5;

	temp2[1] = 0;

	FOREVER
		{
/*
 *	Now do the general iteration case.
 */
		for(shift = 0; temp1[1] != 0; shift++)
			lrshift(temp1);
		temp2[0] = temp1[0] / 5;
		if(temp2[0] == 0)
			{
			if(temp1[0] % 5 > (5 / 2))
				{
				temp1[0] = 1;
				ladd(result,temp1);
				}
			break;
			}
		temp1[0] = temp2[0];
		while(shift-- != 0)
			llshift(temp1);
		ladd(result,temp1);	/* Update result accumulator */
		temp1[0] = result[0];
		temp1[1] = result[1];
		llshift(temp1);		/* Compute (current_result*5) */
		llshift(temp1);
		ladd(temp1,result);
		temp1[0] = ~temp1[0];	/* Compute -(current_result*5) */
		temp1[1] = ~temp1[1];
		temp2[0] = 1;
		ladd(temp1,temp2);
		ladd(temp1,value);	/* Compute #-(current_result*5) */
		}
/*
 *	All done, return result.
 */
	value[0] = result[0];
	value[1] = result[1];
	}

/*
 *	Convert a string to the corresponding IEEE floating point value.
 *
 *	Parameters:
 *			"parse_ptr"	A pointer to the input string.
 *			"result"	A pointer to where to store the result.
 *			"double_precision"	TRUE if a double precision
 *						(64 bit), result is needed.
 *						FALSE if 32 bits desired.
 */
static	char	*
xatof(parse_ptr,result,double_precision)
	char	*parse_ptr;
	ULONG	result[];
	BOOL	double_precision;
	{
	extern	int	errno;

	register char	*cptr;
	register int	c,exp,itemp;
	char	*old_cptr;
	int	esign,expmod,fsign;
	ULONG	fract[2],ltemp[2];

	fract[0] = fract[1] = exp = 0;	/* Reset accumulators */

	cptr = parse_ptr;
	while(isspace(*cptr)) cptr++;
	old_cptr = cptr;
/*
 *	Process sign indication for number (if any).
 */
	if((c = *cptr++) == '-')
		{
		fsign = -1;
		c = *cptr++;
		}
	else if(c == '+')
		{
		fsign = 1;
		c = *cptr++;
		}
	else	fsign = 1;
/*
 *	Process fraction up to the (optional), decimal point.
 */
	while(isdigit(c))
		{
		if(fract[1] < ((ULONG_MAX - 9) / 10))
			{		/* Multiply "fract" by 10 */
			ltemp[0] = fract[0];
			ltemp[1] = fract[1];
			llshift(fract);
			llshift(fract);
			ladd(fract,ltemp);
			llshift(fract);
			ltemp[0] = c - '0';
			ltemp[1] = 0;
			ladd(fract,ltemp);	/* Add digit */
			}
		else	exp++;		/* At precision limit, kick exponent */
		c = *cptr++;
		}
/*
 *	See if we got a decimal point, if so continue accumulating fraction.
 */
	if(c == '.')
		{
		for(c = *cptr++; isdigit(c); c = *cptr++)
			{
			if(fract[1] < ((ULONG_MAX - 9) / 10))
				{	/* Multiply "fract" by 10 */
				ltemp[0] = fract[0];
				ltemp[1] = fract[1];
				llshift(fract);
				llshift(fract);
				ladd(fract,ltemp);
				llshift(fract);
				ltemp[0] = c - '0';
				ltemp[1] = 0;
				ladd(fract,ltemp);	/* Add digit */
				exp--;
				}
			}
		}
/*
 *	See if we have an exponent and process exponent sign.
 */
	if(toupper(c) == 'E')
		{
		expmod = exp;		/* Remember exponent modifier */
		exp = 0;		/* Reset new exponent accumulator */
		if((c = *cptr++) == '-')	/* Check for exponent sign */
			{
			esign = -1;
			c = *cptr++;
			}
		else if(c == '+')
			{
			esign = 1;
			c = *cptr++;
			}
		else	esign = 1;
/*
 *	Process exponent value if one is present.
 */
		while(isdigit(c))
			{
			if(exp < ((INT_MAX - 9) / 10))
				{
				exp = (exp * 10) + c - '0';	/* Add digit */
				}
			c = *cptr++;
			}
/*
 *	Combine exponent modifier and explicit exponent (if any), into the
 *	final value of the base 10 exponent.  Clip the resulting value so
 *	that the following routines won't loop forever if a bogus value is
 *	being parsed.
 */
 		if(esign < 0)
			exp = expmod - exp;
		else
			exp += expmod;
		}
	if(--cptr == old_cptr)		/* Any conversion performed? */
		cptr = parse_ptr;;	/* No, return original pointer */
	if((fract[0] == 0) && (fract[1] == 0))	/* If number was zero */
		{
		if(double_precision)
			{
			result[0] = fract[0];
			result[1] = fract[1];
			}
		else
			result[0] = fract[1];
		return (cptr);
		}
	if(exp > MAXEXP)
		{
		if(double_precision)
			{
			result[0] = 0x00000000;
			result[1] = 0x7FF00000;
			if(fsign < 0)
				result[1] |= 0x80000000;
			}
		else
			{
			result[0] = 0x7F800000;
			if(fsign < 0)
				result[0] |= 0x80000000;
			}
		errno = ERANGE;
		return (cptr);
		}
	else if(exp < -(MAXEXP + 1))
		{
		if(double_precision)
			{
			result[0] = 0;
			result[1] = 0;
			}
		else
			result[0] = 0;
		errno = ERANGE;
		return (cptr);
		}
/*
 *	Now we convert the fraction times base 10 exponent to a fraction times
 *	base 2 exponent.
 */
	itemp = exp;			/* Remember exponent base 10 */
	exp = 0;			/* Reset exponent base 2 */
	if(itemp > 0)			/* If zero, not much to do */
		{
		while(itemp--)		/* Count down base 10 exponent */
			{
/*
 *	Make room in the fraction for the multiplication by 10 by
 *	shifting it right, rounding the result, and incrementing the base 2
 *	exponent.
 */
			while(fract[1] >= (ULONG_MAX / 5))
				{
				ltemp[0] = fract[0] & 1;
				ltemp[1] = 0;
				lrshift(fract);
				ladd(fract,ltemp);	/* Round */
				exp++;		/* Increment binary exponent */
				}
			ltemp[0] = fract[0];
			ltemp[1] = fract[1];
			llshift(fract);
			llshift(fract);
			ladd(fract,ltemp);
			exp++;			/* *10 = (*5) * (*2) */
			}
		}
	else if(itemp < 0)
		{
		while(itemp++)		/* Count up base 10 exponent */
			{
/*
 *	Shift the fraction as far left as possible prior to dividing
 *	it by 10 to minimize the roundoff error.
 */
			while(fract[1] <= (ULONG_MAX / 2))
				{
				llshift(fract);
				exp--;
				}
			ldiv5(fract);
			exp--;		/* Last /2 factor to get /10 */
			}
		}
/*
 *	Okay, the fraction is the final fraction to the appropriate base 2
 *	exponent, and we know the desired sign of the exponent.  Now cram it
 *	into the 32 or 64 bit IEEE formats as appropriate.
 */
	if(double_precision)
		{
		while(fract[1] >= 0x00200000)
			{
			ltemp[0] = fract[0] & 1;
			ltemp[1] = 0;
			lrshift(fract);
			ladd(fract,ltemp);	/* Round */
			exp++;
			}
		while(fract[1] < 0x00100000)
			{
			llshift(fract);
			exp--;
			}
/*
 *	Unlike the earlier rough exponent clipping, this time we make sure
 *	the number can be represented.  If not, we return the appropriate value
 *	and signal (via "errno"), that we had trouble.
 */
		if((exp += (1023 + 52)) > 2047)
			{
			result[0] = 0x00000000;
			result[1] = 0x7FF00000;
			if(fsign < 0)
				result[1] |= 0x80000000;
			errno = ERANGE;
			return (cptr);
			}
		else if(exp < 0)
			{
			result[0] = 0;
			result[1] = 0;
			errno = ERANGE;
			return (cptr);
			}

		ltemp[1] = exp;
		fract[1] = (fract[1] & 0x000FFFFF) | (ltemp[1] << 20);
		if(fsign < 0)
			fract[1] |= 0x80000000;
		result[0] = fract[0];
		result[1] = fract[1];
		}
	else
		{
		while(fract[1] >= 0x01000000)
			{
			ltemp[0] = fract[0] & 1;
			ltemp[1] = 0;
			lrshift(fract);
			ladd(fract,ltemp);	/* Round */
			exp++;
			}
		while(fract[1] < 0x00800000)
			{
			llshift(fract);
			exp--;
			}
/*
 *	Since we are only returning the top word as our result mantissa, round
 *	it based on the low order word.
 */
		if(fract[0] & 0x80000000)
			fract[1]++;
		if(fract[1] >= 0x01000000)	/* Handle carry */
			{
			lrshift(fract);
			exp++;
			}
/*
 *	Unlike the earlier rough exponent clipping, this time we make sure
 *	the number can be represented.  If not, we return the appropriate value
 *	and signal (via "errno"), that we had trouble.
 */
		if((exp += (127 + 55)) > 255)
			{
			result[0] = 0x7F800000;
			if(fsign < 0)
				result[0] |= 0x80000000;
			errno = ERANGE;
			return (cptr);
			}
		else if(exp < 0)
			{
			result[0] = 0;
			errno = ERANGE;
			return (cptr);
			}
		ltemp[1] = exp;
		fract[1] = (fract[1] & 0x007FFFFF) | (ltemp[1] << 23);
		if(fsign < 0)
			fract[1] |= 0x80000000;
		result[0] = fract[1];
		}
	return (cptr);
	}
#ifndef	DEBUG
/*
 *	atof
 */
double
atof(cptr)
	const	char	*cptr;
	{
	double	result;

#ifdef	DOUBLE32			/* Library control variable */
	(void) xatof(cptr,&result,FALSE);
#else
	(void) xatof(cptr,&result,TRUE);
#endif	/* DOUBLE32 */
	return (result);
	}

/*
 *	strtod
 */
double
strtod(nptr,endptr)
	const	char	*nptr;
	char	**endptr;
	{
	double	result;

	if(endptr != NULL)
#ifdef	DOUBLE32			/* Library control variable */
		*endptr = xatof(nptr,&result,FALSE);
#else
		*endptr = xatof(nptr,&result,TRUE);
#endif	/* DOUBLE32 */
	else
#ifdef	DOUBLE32			/* Library control variable */
		(void) xatof(nptr,&result,FALSE);
#else
		(void) xatof(nptr,&result,TRUE);
#endif	/* DOUBLE32 */
	return (result);
	}
#endif	/* !DEBUG */
