/************************************************************************/
/*									*/
/*	File:	calloc.c						*/
/*									*/
/*	Allocates and initialize a specified amount of heap memory.	*/
/*									*/
/*	Uses an optimized boundary tag algorithm with an in-use		*/
/*	overhead of one word per block.					*/
/*									*/
/*	Copyright (C) 1988 by Logical Systems.				*/
/*									*/
/*	Last update:	1/26/88						*/
/*									*/
/************************************************************************/

#define		NOTMALLOC
#include	"../malloc.c"		/* Info for dynamic memory routines */

void	*
calloc(nmemb,size)
	size_t	nmemb,size;
	{
	register size_t	*uptr,usize;
	char	*mptr;

	if((mptr = (char *) malloc(size *= nmemb)) == NULL)
		return (NULL);
	uptr = (size_t *) mptr;
	usize = ((size + ((size_t) sizeof(size_t)) - 1) /
					((size_t) sizeof(size_t))) + 1;
	while(--usize)
		*uptr++ = 0;
	return ((void *) mptr);
	}
