/*
 *	File:	cos32.c
 *
 *	Implements T800/T414 32 bit floating point "cosf(x)/cos(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
cosf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	cos
cos:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	_asm_ajw(-9);
	.ldc	data
	stl	8
	.ldc	0
	stl	5
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	5
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	6
	fpstnlsn
	ldl	5
	cj	@L1
	ldl	[x]
	stl	7
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L10
	.align
data:	.dw	0x46490fdb
	.dw	0x7f800004
	.dw	0x39800000
	.dw	0x3f800000
	.dw	0x3fc90fdb
	.dw	0x3ea2f983
	.dw	0x00000000
	.dw	0x3fe00000
	.dw	0x54442d18
	.dw	0x400921fb
	.dw	0x3fc907db
	.dw	0x362e9c5b
	.dw	0xb94fb223
	.dw	0x3c08873e
	.dw	0xbe2aaaa4
L1:	ldlp	6
	fpldnlsn
	ldl	8
	fpldnlsn
	fpgt
	cj	@L2
	ldl	8
	ldnl	1
	stl	7
	j	@L10
L2:	ldl	8
	ldnlp	2
	fpldnlsn
	ldlp	6
	fpldnlsn
	fpgt
	cj	@L3
	ldl	8
	ldnl	3
	stl	7
	j	@L10
L3:	ldlp	6
	ldl	8
	ldnlp	4
	fpldnlsn
	fpldnladdsn
	ldl	8
	ldnlp	5
	fpldnlmulsn
	fprtoi32
	ldlp	4
	fpstnli32
	.ldc	0
	stl	3
	ldl	4
	.ldc	1
	and
	eqc	1
	stl	3
	ldlp	4
	fpi32tor64
	ldlp	0
	fpstnldb
	ldlp	6
	fpldnlsn
	fpur32tor64
	ldl	8
	ldnlp	6
	ldlp	0
	fpldnldb
	fpldnldb
	fpsub
	ldl	8
	ldnlp	8
	fpldnlmuldb
	fpsub
	fpur64tor32
	ldlp	6
	fpstnlsn
	fpldzerosn
	ldlp	6
	fpldnlsn
	fpgt
	cj	@L4
	fpldzerosn
	ldlp	6
	fpldnlsn
	fpsub
	ldlp	6
	fpstnlsn
	ldl	3
	eqc	0
	stl	3
L4:	ldl	8
	ldnlp	2
	fpldnlsn
	ldlp	6
	fpldnlsn
	fpgt
	cj	@L5
	ldl	6
	stl	2
	j	@L7
L5:	ldlp	6
	fpldnlsn
	ldl	8
	ldnlp	10
	fpldnlsn
	fpgt
	cj	@L6
	ldl	8
	ldnl	3
	stl	2
	j	@L7
L6:	ldlp	6
	ldlp	6
	fpldnlsn
	fpldnlmulsn
	ldlp	1
	fpstnlsn
	ldl	8
	ldnlp	11
	ldlp	1
	fpldnlsn
	fpldnlmulsn
	ldl	8
	ldnlp	12
	fpldnladdsn
	ldlp	1
	fpldnlmulsn
	ldl	8
	ldnlp	13
	fpldnladdsn
	ldlp	1
	fpldnlmulsn
	ldl	8
	ldnlp	14
	fpldnladdsn
	ldlp	1
	fpldnlmulsn
	ldlp	6
	fpldnlmulsn
	ldlp	6
	fpldnladdsn
	ldlp	2
	fpstnlsn
L7:	ldl	3
	cj	@L9
	fpldzerosn
	ldlp	2
	fpldnlsn
	fpsub
	ldlp	7
	fpstnlsn
	j	@L10
L9:	ldl	2
	stl	7
L10:	ldlp	7
	fpldnlsn
	_asm_ajw(9);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
