/*
 *	File:	exp32.c
 *
 *	Implements T800/T414 32 bit floating point "expf(x)/exp(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
expf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	exp
exp:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	_argrf
	.ext	errno
	.ext	_scalef
	_asm_ajw(-10);
	.ldc	data
	stl	13
	.ldc	0
	stl	8
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	8
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	7
	fpstnlsn
	ldl	8
	cj	@L1
	ldl	[x]
	stl	9
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L6
	.align
data:	.dw	0x42b00f34
	.dw	0x7f800000
	.dw	0x4e2eac51
	.dw	0x33000000
	.dw	0x3f800000
	.dw	0xb102e308
	.dw	0x3f317218
	.dw	0x3b885308
	.dw	0x3e800000
	.dw	0x3d4cbf5c
	.dw	0x3f000000
L1:	ldlp	[x]
	fpldnlsn
	ldl	13
	fpldnlsn
	fpgt
	cj	@L2
	ldl	13
	ldnl	1
	stl	9
	.ldc	ERANGE			;Input too large signal range error
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	j	@L6
L2:	fpldzerosn
	ldlp	[x]
	fpldnlsn
	fpgt
	cj	@L3
	ldlp	7
	fpldnlsn
	ldl	13
	ldnlp	2
	fpldnlsn
	fpgt
	cj	@L3
	fpldzerosn
	ldlp	9
	fpstnlsn
	j	@L6
L3:	ldl	13
	ldnlp	3
	fpldnlsn
	ldlp	7
	fpldnlsn
	fpgt
	cj	@L5
	ldl	13
	ldnl	4
	stl	9
	j	@L6
L5:	.ldc	0
	stl	3
	ldl	13
	ldnl	5
	stl	2
	ldl	13
	ldnl	6
	stl	1
	ldl	[x]
	stl	0
	ldlp	6
	ldlp	4
	ldlp	3
	call	@_argrf
	ldlp	6
	ldlp	6
	fpldnlsn
	fpldnlmulsn
	ldlp	3
	fpstnlsn
	ldlp	3
	ldl	13
	ldnlp	7
	fpldnlsn
	fpldnlmulsn
	ldl	13
	ldnlp	8
	fpldnladdsn
	ldlp	6
	fpldnlmulsn
	ldlp	2
	fpstnlsn
	ldlp	2
	fpldnlsn
	ldlp	3
	ldl	13
	ldnlp	9
	fpldnlsn
	fpldnlmulsn
	ldl	13
	ldnlp	10
	fpldnladdsn
	ldlp	2
	fpldnlsn
	fpsub
	fpdiv
	ldl	13
	ldnlp	10
	fpldnladdsn
	ldlp	5
	fpstnlsn
	ldl	4
	adc	1
	ldl	5
	ldlp	9
	call	@_scalef
L6:	ldlp	9
	fpldnlsn
	_asm_ajw(10);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
