/*
 *	File:	floor64.c
 *
 *	Implements T800/T414 64 bit floating point "floor(x)".
 *
 *	Copyright 1987-1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
floor(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	ldlp	[x]
	fpldnldb
	fpnan				;Input NaN?
	cj	@L1			;Jump if not
	.ldc	EDOM			;Domain error
	_asm_eval1(&errno);
	stnl	0			;Signal "domain" error
	ret
L1	fpurm
	fpint
	ret
#else	/* T800 */
;
;	T414 64 bit version
;
	.ext	errno
	.ext	_FPstate
	.ext	_r64fei
	.ext	_r64op
	.ext	_r64tei
	_asm_ajw(-5)
	.ldc	0x7FF00000		;NaN/Inf dividing line
	ldl	[x]+1
	gt
	eqc	0
	cj	@L0			;Jump if not NaN/Inf
	ldlp	[x]			;Return "x" (NaN/Inf)
	.ldc	_FPstate
	.ldc	8
	move
	.ldc	EDOM			;Domain error
	_asm_eval1(&errno);
	stnl	0			;Signal "domain" error
	j	@L3
L0:	ldlp	[x]
	.ldc	0			;Truncate result
	ldlp	1
	call	@_r64tei		;Convert to 64 bit integer
	ldlp	1			;Temp storage
	.ldc	0			;Truncate result
	ldlp	3
	call	@_r64fei		;Convert back to double
	ldl	3
	ldl	[x]			;Was it already integral?
	diff
	eqc	0
	cj	@L1			;Jump if not
	ldl	4
	ldl	[x]+1
	diff
	cj	@L2			;Jump if already integral
L1:
	ldl	[x]+1			;Is "x" positive?
	mint
	and
	cj	@L2			;Jump if so
	.ldc	0			;Load -1.0 up
	stl	1
	.ldc	0xBFF00000
	stl	2
	ldlp	3			;Truncated version of "x"
	stl	0
	.ldc	0			;We need a add
	ldlp	1			;-1.0
	.ldc	_FPstate
	call	@_r64op			;Add -1.0 to truncated version
	j	@L3
L2:	ldlp	3
	.ldc	_FPstate
	.ldc	8
	move
L3:	_asm_ajw(5)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
