/*
 *	File:	frand32.c
 *
 *	Implements T800/T414 32 bit floating point "frandf(void)/frand(void)".
 *	Uses the "rand" function to get a random integer to build the floating
 *	point # out of.
 *
 *	Returns a floating point value between 0 and 1.
 *
 *	Loosely based on INMOS supplied code, modifications by Logical Systems.
 */

#include	<inline.h>
#include	<stdlib.h>

float	frandf(void)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	frand
frand:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	rand
	_asm_ajw(-3);
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@rand			;Get random #
	dup
	stl	5
	eqc	0
	cj	@L1
	.ldc	0
	stl	6
	j	@L5
L1:	ldl	5
	.ldc	0
	norm
	stl	1
	stl	0
	stl	2
	ldl	0
	mint
	not
	and
	.ldc	0
	.ldc	8
	lshr
	stl	1
	stl	0
	.ldc	127
	ldl	2
	sub
	.ldc	23
	shl
	ldl	0
	or
	stl	0
	.ldc	0
	ldl	1
	gt
	eqc	0
	cj	@L2
	ldl	0
	stl	6
	j	@L5
L2:	ldl	1
	eqc	-2147483648
	eqc	0
	cj	@L3
	ldl	0
	adc	1
	stl	6
	j	@L5
L3:	ldl	0
	.ldc	1
	and
	eqc	1
	cj	@L4
	ldl	0
	adc	1
	stl	6
	j	@L5
L4:	ldl	0
	stl	6
L5:	ldlp	6
	fpldnlsn
	_asm_ajw(3);
#else	/* T800 */
;
;	T414 32 bit version
;
	.ext	?SN32TOFAREG
	.ext	rand
	_asm_ajw(-3);
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@rand			;Get random #
	stl	5
	ldl	5
	eqc	0
	cj	@L1
	.ldc	0
	stl	6
	j	@L5
L1:	ldl	5
	.ldc	0
	norm
	stl	1
	stl	0
	stl	2
	ldl	0
	mint
	not
	and
	.ldc	0
	.ldc	8
	lshr
	stl	1
	stl	0
	.ldc	127
	ldl	2
	sub
	.ldc	23
	shl
	ldl	0
	or
	stl	0
	.ldc	0
	ldl	1
	gt
	eqc	0
	cj	@L2
	ldl	0
	stl	6
	j	@L5
L2:	ldl	1
	eqc	-2147483648
	eqc	0
	cj	@L3
	ldl	0
	adc	1
	stl	6
	j	@L5
L3:	ldl	0
	.ldc	1
	and
	eqc	1
	cj	@L4
	ldl	0
	adc	1
	stl	6
	j	@L5
L4:	ldl	0
	stl	6
L5:	ldl	6
	call	@?SN32TOFAREG		;Store 32 bit fp in A into FAreg
	_asm_ajw(3);
#endif	/* T800 */
	#pragma	endasm
	}
