/*
 *	File:	frand64.c
 *
 *	Implements T800/T414 64 bit floating point "frand()".  Uses the "rand"
 *	function to get two random integers to build the floating point # out
 *	of.
 *
 *	Returns a floating point value between 0 and 1.
 *
 *	Loosely based on INMOS supplied code, modifications by Logical Systems.
 */

#include	<inline.h>
#include	<stdlib.h>

double
frand(void)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	rand
	_asm_ajw(-13);
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@rand			;Get low word of frand seed
	stl	15
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@rand			;Get high word of frand seed
	stl	16
	.ldc	data
	stl	12
	.ldc	0
	ldl	15
	ldl	12
	ldnl	0
	lmul
	stl	9
	stl	6
	ldl	6
	ldl	15
	ldl	12
	ldnl	1
	lmul
	stl	8
	stl	5
	ldl	8
	ldl	16
	ldl	12
	ldnl	0
	lmul
	stl	7
	stl	6
	.ldc	0
	.ldc	1
	ldl	9
	lsum
	stl	15
	stl	6
	ldl	6
	.ldc	0
	ldl	7
	lsum
	stl	16
	stl	6
	ldl	15
	ldl	16
	or
	eqc	0
	cj	@L1
	fpldzerodb			;Both words of seed are zero
	ajw	13
	ret
	.align
data:	.dw	0x4c957f2d
	.dw	0x5851f42d
	.dw	0x7fffffff
L1:	ldl	16
	cj	@L2
	ldl	16
	ldl	15
	.ldc	1
	lshr
	stl	2
	stl	3
	ldl	3
	ldl	2
	norm
	stl	0
	stl	3
	stl	1
	ldl	2
	.ldc	0
	ldl	1
	lshl
	stl	0
	stl	2
	j	@L3
L2:	ldl	15
	.ldc	0
	norm
	stl	0
	stl	3
	stl	1
	.ldc	0
	stl	2
	ldl	1
	adc	32
	adc	1
	stl	1
L3:	ldl	1
	stl	4
	ldl	3
	ldl	12
	ldnl	2
	and
	ldl	2
	.ldc	11
	lshr
	stl	10
	stl	3
	.ldc	1023
	ldl	4
	sub
	.ldc	20
	shl
	ldl	3
	or
	stl	11
L4:	ldlp	10
	fpldnldb
	_asm_ajw(13);
#else	/* T800 */
;
;	T414 64 bit version
;
	.ext	_FPstate
	.ext	rand
	_asm_ajw(-13);
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@rand			;Get low word of frand seed
	stl	15
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@rand			;Get high word of frand seed
	stl	16
	.ldc	data
	stl	12
	.ldc	0
	ldl	15
	ldl	12
	ldnl	0
	lmul
	stl	9
	stl	6
	ldl	6
	ldl	15
	ldl	12
	ldnl	1
	lmul
	stl	8
	stl	5
	ldl	8
	ldl	16
	ldl	12
	ldnl	0
	lmul
	stl	7
	stl	6
	.ldc	0
	.ldc	1
	ldl	9
	lsum
	stl	15
	stl	6
	ldl	6
	.ldc	0
	ldl	7
	lsum
	stl	16
	stl	6
	ldl	15
	ldl	16
	or
	eqc	0
	cj	@L1
	ldlp	15
	.ldc	_FPstate
	.ldc	8
	move				;Both words of seed are zero
	ajw	13
	ret
	.align
data:	.dw	0x4c957f2d
	.dw	0x5851f42d
	.dw	0x7fffffff
L1:	ldl	16
	cj	@L2
	ldl	16
	ldl	15
	.ldc	1
	lshr
	stl	2
	stl	3
	ldl	3
	ldl	2
	norm
	stl	0
	stl	3
	stl	1
	ldl	2
	.ldc	0
	ldl	1
	lshl
	stl	0
	stl	2
	j	@L3
L2:	ldl	15
	.ldc	0
	norm
	stl	0
	stl	3
	stl	1
	.ldc	0
	stl	2
	ldl	1
	adc	32
	adc	1
	stl	1
L3:	ldl	1
	stl	4
	ldl	3
	ldl	12
	ldnl	2
	and
	ldl	2
	.ldc	11
	lshr
	stl	10
	stl	3
	.ldc	1023
	ldl	4
	sub
	.ldc	20
	shl
	ldl	3
	or
	stl	11
L4:	ldlp	10
	.ldc	_FPstate
	.ldc	8
	move
	_asm_ajw(13);
#endif	/* T800 */
	#pragma	endasm
	}
