/*
 *	File:	frexp32.c
 *
 *	Implements T800/T41432 bit floating point "frexpf(x,y)/frexp(x,y)".
 *
 *	Copyright 1988, 1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>

float
frexpf(float x,int *y)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	frexp
frexp:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	ldl	[x]			;Get "value"
	mint
	not
	and				;Mask off sign bit
	eqc	0
	cj	@L1			;Jump if value isn't zero
	.ldc	0
	ldl	[y]			;Get address of "exp"
	stnl	0			;Exponent is zero
	fpldzerosn			;Return zero as result
	ret
L1	ldl	[x]			;Get value
	.ldc	23
	shr				;Right justify exponent field
	.ldc	0xFF
	and				;Mask off everything but exponent
	adc	-126			;Remove exp bias (remember implied 1)
	ldl	[y]			;Get address of "exp"
	stnl	0			;Return exponent value
	ldl	[x]			;Get value
	.ldc	0x807FFFFF
	and				;Remove exponent field
	.ldc	0x3F000000
	or				;Put "-1" value exponent bias in
	stl	[x]
	ldlp	[x]
	fpldnlsn			;Load as floating point #
#else	/* T800 */
;
;	T414 32 bit version
;
	.ext	?SN32TOFAREG
	ldl	[x]			;Get "value"
	mint
	not
	and				;Mask off sign bit
	eqc	0
	cj	@L1			;Jump if value isn't zero
	.ldc	0
	ldl	[y]			;Get address of "exp"
	stnl	0			;Exponent is zero
	.ldc	0
	.ldc	0
	cj	@L2			;Return zero as result
L1	ldl	[x]			;Get value
	.ldc	23
	shr				;Right justify exponent field
	.ldc	0xFF
	and				;Mask off everything but exponent
	adc	-126			;Remove exp bias (remember implied 1)
	ldl	[y]			;Get address of "exp"
	stnl	0			;Return exponent value
	ldl	[x]			;Get value
	.ldc	0x807FFFFF
	and				;Remove exponent field
	.ldc	0x3F000000
	or				;Put "-1" value exponent bias in
	.ldc	0
L2
	stl	[x]			;Toss A
	call	@?SN32TOFAREG		;Store 32 bit fp in A into FAreg
#endif	/* T800 */
	#pragma	endasm
	}
