/*
 *	File:	ldexp64.c
 *
 *	Implements T800/T414 64 bit floating point "ldexp()".
 *
 *	Copyright 1988,1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
ldexp(double x,int y)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	ldl	[x]+1			;Get high word of value
	mint
	not
	and				;Mask off sign bit
	ldl	[x]			;Get low word of value
	or
	eqc	0
	cj	@L1			;Jump if value isn't zero
	fpldzerodb			;Otherwise return zero as result
	ret
L1	ldl	[x]+1			;Get high word of value
	.ldc	20
	shr				;Right justify exponent field
	.ldc	0x7FF
	and				;Mask off everything but exponent
	ldl	[y]			;Get exponent modifier
	add
	dup				;Save a copy of prototype exponent
	.ldc	0
	gt
	cj	@L2			;Jump if exponent <= 0
	dup				;Save a copy of prototype exponent
	.ldc	2046
	gt
	cj	@L3			;Jump if 0 < exponent < 2047
L2	.ldc	undefined
	fpldnldb			;Load "undefined" NaN
	.ldc	ERANGE
	_asm_eval1(&errno);
	stnl	0
	ret
	.align
undefined
	.dw	0x00000000		;"undefined" NaN low word
	.dw	0x7FF00002		;"undefined" NaN high word
L3	add				;Remove 0 from stack top
	.ldc	20
	shl				;Position future exponent field
	ldl	[x]+1			;Get original high word of value
	.ldc	0x800FFFFF
	and				;Mask off original exponent
	or				;Mask in new exponent
	stl	[x]+1
	ldlp	[x]
	fpldnldb			;Load resulting value
#else	/* T800 */
;
;	T414 64 bit version
;
	.ext	errno
	.ext	_FPstate
	ldl	[x]+1			;Get high word of value
	mint
	not
	and				;Mask off sign bit
	ldl	[x]			;Get low word of value
	or
	eqc	0
	cj	@L1			;Jump if value isn't zero
	.ldc	0
	stl	[x]+1			;Zero out high word in case -0
	j	@L4			;Return 0
L1	ldl	[x]+1			;Get high word of value
	.ldc	20
	shr				;Right justify exponent field
	.ldc	0x7FF
	and				;Mask off everything but exponent
	ldl	[y]			;Get exponent modifier
	add
	stl	[y]			;Save a copy of prototype exponent
	ldl	[y]
	ldl	[y]			;Push a copy onto the stack
	.ldc	0
	gt
	cj	@L2			;Jump if exponent <= 0
	ldl	[y]			;Save a copy of prototype exponent
	.ldc	2046
	gt
	cj	@L3			;Jump if 0 < exponent < 2047
L2	.ldc	undefined		;Load "undefined" NaN
	.ldc	_FPstate		;Destination (FAreg)
	.ldc	8
	move
	.ldc	ERANGE
	_asm_eval1(&errno);
	stnl	0
	ret
	.align
undefined
	.dw	0x00000000		;"undefined" NaN low word
	.dw	0x7FF00002		;"undefined" NaN high word
L3	add				;Remove 0 from stack top
	.ldc	20
	shl				;Position future exponent field
	ldl	[x]+1			;Get original high word of value
	.ldc	0x800FFFFF
	and				;Mask off original exponent
	or				;Mask in new exponent
	stl	[x]+1
L4	ldlp	[x]
	.ldc	_FPstate		;Destination (FAreg)
	.ldc	8
	move				;Load resulting value into FAreg
#endif	/* T800 */
	#pragma	endasm
	}
