/*
 *	procmisc.c
 *
 *	Miscellaneous process primitives for the Transputer.
 *
 *	Based on the Transputer concurrency function library designed by
 *	Jeffrey Mock of PIXAR (Version 2).  This implementation by Scott Lloyd
 *	of CSA.  Additional functions provided by Logical Systems.
 *
 *	Copyright (C) Computer System Architects and Logical Systems, 1987.
 */

#include	<inline.h>
#include	<conc.h>

#undef	ProcAfter

void
ProcAfter(int time)
	{
	#pragma asm
	LDL	[time]
	TIN
	#pragma endasm
	}

int
ProcCall(int (*func)(), void *ws, int wssize, ...)
	{
	#pragma asm
;	nwsp at offset 0
	_asm_ajw(-1);
	LDL	[ws]			;Save new wsp
	LDL	[wssize]
	ADD
	.LDC	7
	BCNT				;Amount to reserve in new WS
	DIFF
	STL	0
	LDLP	[wssize]+1		;Src, copy parameters
	LDL	0			;Dst
	LDNLP	1
	.LDC	5
	BCNT				;Cnt (bytes)
	MOVE
	.LDC	PC2-PC1			;Save return iptr
	LDPI
PC1
	LDL	0
	STNL	0
	LDL	[func]			;Load function entry
	LDL	0			;Adjust wsp to new area
	GAJW
	STL	6
	GCALL				;Call function
PC2
	LDL	2			;Restore wsp
	GAJW
	STL	0
	_asm_ajw(1);
	#pragma endasm
	}

#undef	ProcGetPriority

int
ProcGetPriority(void)
	{
	#pragma asm
	LDPRI
	#pragma endasm
	}

#undef	ProcReschedule

void
ProcReschedule(void)
	{
	#pragma asm
	LDLP	0
	LDPRI
	OR
	RUNP
	STOPP
	#pragma endasm
	}

#undef	ProcStop

void
ProcStop(void)
	{
	#pragma asm
	STOPP
	#pragma endasm
	}

#undef	ProcWait

void
ProcWait(int time)
	{
	#pragma asm
	LDTIMER
	LDL	[time]
	SUM
	TIN
	#pragma endasm
	}

#undef	SetTime

void
SetTime(int t)
	{
	#pragma asm
	ldl	[t]
	sttimer
	#pragma endasm
	}

#undef	Time

int
Time(void)
	{
	#pragma asm
	LDTIMER
	#pragma endasm
	}
