/*
 *	File:	sin64.c
 *
 *	Implements T800/T414 64 bit floating point "sin(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
sin(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	_argr
	.ext	errno
	_asm_ajw(-19)
	.ldc	data
	stl	18
	.ldc	0
	stl	13
	ldlp	[x]
	fpldnldb
	fpnan
	stl	13
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	16
	fpstnldb
	ldl	13
	cj	@L1
	ldlp	[x]
	ldlp	14
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L12
	.align
data:	.dw	0x54442d18
	.dw	0x41a921fb
;
;	The following floating point constant represents the value of the
;	"inaccurate" NaN.  The original INMOS code used a value for this which
;	is inconsistent with the latest INMOS Compiler Writers' Guide.  The
;	value has been changed to reflect the one used in the "Guide".
;
	.dw	0x80000000		;Was 0x00000004
	.dw	0x7ff00000		;Was 0x7FF00000
	.dw	0x54442d18
	.dw	0x3ff921fb
	.dw	0x54442d18
	.dw	0x400921fb
	.dw	0x33145c07
	.dw	0x3ca1a626
	.dw	0x00000000
	.dw	0x3e500000
	.dw	0x50442d18
	.dw	0x3ff921fb
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x6993df95
	.dw	0x3ce880ff
	.dw	0xdc08499c
	.dw	0xbd6ae420
	.dw	0x686ad430
	.dw	0x3de6123c
	.dw	0x4b5dc0ac
	.dw	0xbe5ae645
	.dw	0xa524f064
	.dw	0x3ec71de3
	.dw	0x1a013e1b
	.dw	0xbf2a01a0
	.dw	0x111110b1
	.dw	0x3f811111
	.dw	0x55555555
	.dw	0xbfc55555
L1:	ldlp	16
	fpldnldb
	ldl	18
	fpldnldb
	fpgt
	cj	@L2
	ldl	18
	ldnlp	2
	ldlp	14
	.ldc	8
	move
	j	@L12
L2:	.ldc	0
	stl	10
	ldlp	16
	fpldnldb
	ldl	18
	ldnlp	4
	fpldnldb
	fpgt
	cj	@L5
	.ldc	0
	stl	9
	.ldc	0
	stl	7
	ldl	18
	ldnlp	6
	ldlp	5
	.ldc	8
	move
	ldl	18
	ldnlp	8
	ldlp	3
	.ldc	8
	move
	ldlp	3
	stl	2
	ldlp	5
	stl	1
	ldlp	16
	stl	0
	ldlp	16
	ldlp	8
	ldlp	7
	call	@_argr
	ldl	8
	.ldc	1
	and
	eqc	1
	stl	9
	fpldzerodb
	ldlp	16
	fpldnldb
	fpgt
	cj	@L3
	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	ldl	9
	diff
	eqc	0
	stl	10
	fpldzerodb
	ldlp	16
	fpldnldb
	fpsub
	ldlp	16
	fpstnldb
	j	@L4
L3:	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	ldl	9
	diff
	eqc	0
	eqc	0
	stl	10
L4:	j	@L6
L5:	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	stl	10
L6:	ldl	18
	ldnlp	10
	fpldnldb
	ldlp	16
	fpldnldb
	fpgt
	cj	@L7
	ldl	16
	stl	11
	ldl	17
	stl	12
	j	@L9
L7:	ldlp	16
	fpldnldb
	ldl	18
	ldnlp	12
	fpldnldb
	fpgt
	cj	@L8
	ldl	18
	ldnlp	14
	ldlp	11
	.ldc	8
	move
	j	@L9
L8:	ldlp	16
	ldlp	16
	fpldnldb
	fpldnlmuldb
	ldlp	8
	fpstnldb
	ldlp	8
	ldl	18
	ldnlp	16
	fpldnldb
	fpldnlmuldb
	ldl	18
	ldnlp	18
	fpldnladddb
	ldlp	8
	fpldnlmuldb
	ldl	18
	ldnlp	20
	fpldnladddb
	ldlp	8
	fpldnlmuldb
	ldl	18
	ldnlp	22
	fpldnladddb
	ldlp	8
	fpldnlmuldb
	ldl	18
	ldnlp	24
	fpldnladddb
	ldlp	8
	fpldnlmuldb
	ldl	18
	ldnlp	26
	fpldnladddb
	ldlp	8
	fpldnlmuldb
	ldl	18
	ldnlp	28
	fpldnladddb
	ldlp	8
	fpldnlmuldb
	ldl	18
	ldnlp	30
	fpldnladddb
	ldlp	8
	fpldnlmuldb
	ldlp	16
	fpldnlmuldb
	ldlp	16
	fpldnladddb
	ldlp	11
	fpstnldb
L9:	ldl	10
	cj	@L11
	fpldzerodb
	ldlp	11
	fpldnldb
	fpsub
	ldlp	14
	fpstnldb
	j	@L12
L11:	ldl	11
	stl	14
	ldl	12
	stl	15
L12:	ldlp	14
	fpldnldb
	_asm_ajw(19)
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (for example see lines after label "L3", hope
;	to get to this someday...)
;
	.ext	errno
	.ext	_fix64
	.ext	_fmul64
	.ext	_FPstate
	.ext	_iexp64
	.ext	_refl64
	.ext	_r64fmi
	.ext	_r64op
	.ext	_r64toi
	_asm_ajw(-21)
	.ldc	data
	stl	20
	ldlp	[x]
	ldlp	16
	.ldc	8
	move
	ldlp	14
	stl	13
	.ldc	0
	stl	12
	.ldc	0
	ldl	17
	gt
	stl	12
	ldl	16
	ldl	13
	stnl	0
	ldl	17
	.ldc	2147483647		;~MOSTNEG
	and
	ldl	13
	stnl	1
	.ldc	2146435072		;MSW RealInf
	ldl	13
	ldnl	1
	gt
	eqc	0
	cj	@L2
	.ldc	2146435072		;MSW RealInf
	ldl	13
	ldnl	1
	diff
	eqc	0
	cj	@L1
	mint
	ldl	13
	ldnl	0
	mint
	xor
	gt
L1:	eqc	0
L2:	cj	@L5
	ldl	13
	ldnl	0
	ldl	13
	ldnl	1
	.ldc	2146435072		;MSW RealInf
	diff
	or
	eqc	0
	cj	@L3
	ldl	20
	ldlp	18
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is Inf)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L4
	.align
data:	.dw	0x00000000		;"undefined" NaN
	.dw	0x7ff00002
	.dw	0x80000000		;"inexact" NaN
	.dw	0x7ff00000
	.dw	0x6dc9c883
	.dw	0x3fd45f30
	.dw	0x00000000
	.dw	0x40092200
	.dw	0x4b9ee59e
	.dw	0xbee2aeef
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x6203fda6
	.dw	0x00000000
	.dw	0x00000000
	.dw	0x00000000
L3:	ldl	16
	stl	10
	ldl	17
	stl	11
	ldl	10
	stl	18
	ldl	11
	stl	19
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
L4:	j	@L22
L5:	ldl	13
	ldnl	1
	.ldc	1101603323
	gt
	eqc	0
	cj	@L7
	ldl	13
	ldnl	1
	.ldc	1101603323
	diff
	eqc	0
	cj	@L6
	ldl	13
	ldnl	0
	mint
	xor
	.ldc	-733729512
	gt
L6:	eqc	0
L7:	eqc	0
	cj	@L8
	ldl	20
	ldnlp	2
	ldlp	18
	.ldc	8
	move
	j	@L22
L8:	ldl	13
	ldnl	1
	.ldc	1073291771
	gt
	eqc	0
	cj	@L10
	ldl	13
	ldnl	1
	.ldc	1073291771
	diff
	eqc	0
	cj	@L9
	ldl	13
	ldnl	0
	mint
	xor
	.ldc	-733729512
	gt
L9:	eqc	0
L10:	eqc	0
	cj	@L12
	ldl	13
	stl	11
	ldl	20
	ldnlp	4
	stl	0
	.ldc	2
	ldl	11
	ldlp	8
	call	@_r64op
	ldlp	8
	.ldc	1
	call	@_r64toi
	stl	10
	ldl	10
	ldlp	8
	call	@_r64fmi
	.ldc	0
	stl	7
	ldl	10
	.ldc	1
	and
	eqc	1
	stl	7
	ldl	20
	ldnlp	6
	stl	0
	.ldc	2
	ldlp	8
	ldlp	3
	call	@_r64op
	ldlp	3
	stl	0
	.ldc	1
	ldl	11
	ldlp	1
	call	@_r64op
	ldl	20
	ldnlp	8
	stl	0
	.ldc	2
	ldlp	8
	ldlp	3
	call	@_r64op
	ldlp	3
	stl	0
	.ldc	1
	ldlp	1
	ldlp	5
	call	@_r64op
	ldlp	5
	ldl	11
	.ldc	8
	move
	ldl	11
	stl	6
	.ldc	0
	ldl	6
	ldnl	1
	gt
	cj	@L11
	ldl	7
	ldl	12
	diff
	eqc	0
	stl	12
	ldl	6
	ldnl	0
	stl	4
	ldl	6
	ldnl	1
	.ldc	2147483647
	and
	stl	5
	ldlp	4
	ldl	6
	.ldc	8
	move
	j	@L12
L11:	ldl	7
	ldl	12
	diff
	eqc	0
	eqc	0
	stl	12
L12:	.ldc	1045430272
	ldl	13
	ldnl	1
	gt
	eqc	0
	cj	@L15
	.ldc	1045430272
	ldl	13
	ldnl	1
	diff
	eqc	0
	cj	@L14
	mint
	ldl	13
	ldnl	0
	mint
	xor
	gt
L14:	eqc	0
L15:	eqc	0
	cj	@L16
	ldl	13
	stl	11
	ldl	11
	ldlp	18
	.ldc	8
	move
	j	@L20
L16:	ldl	13
	ldnl	1
	.ldc	1073291771
	gt
	eqc	0
	cj	@L18
	ldl	13
	ldnl	1
	.ldc	1073291771
	diff
	eqc	0
	cj	@L17
	ldl	13
	ldnl	0
	mint
	xor
	.ldc	-800838376
	gt
L17:	eqc	0
L18:	eqc	0
	cj	@L19
	ldl	20
	ldnlp	10
	ldlp	18
	.ldc	8
	move
	j	@L20
L19:	ldl	13
	stl	9
	.ldc	-1
	ldl	9
	ldlp	7
	call	@_iexp64
	ldlp	7
	ldlp	10
	call	@_fix64
	ldlp	10
	ldlp	10
	ldlp	7
	call	@_fmul64
	ldl	7
	stl	10
	ldl	8
	stl	11
	ldl	20
	ldnlp	12
	ldlp	10
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	467608568
	lsum
	stl	3
	ldl	8
	.ldc	-27
	ladd
	stl	4
	ldlp	3
	ldlp	10
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	-1894114635
	lsum
	stl	3
	ldl	6
	.ldc	1412
	ladd
	stl	4
	ldlp	3
	ldlp	10
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	-710602245
	lsum
	stl	3
	ldl	8
	.ldc	-55091
	ladd
	stl	4
	ldlp	3
	ldlp	10
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	-1524305821
	lsum
	stl	3
	ldl	6
	.ldc	1514979
	ladd
	stl	4
	ldlp	3
	ldlp	10
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	1609309790
	lsum
	stl	3
	ldl	8
	.ldc	-27269634
	ladd
	stl	4
	ldlp	3
	ldlp	10
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	286306316
	lsum
	stl	3
	ldl	6
	.ldc	286331153
	ladd
	stl	4
	ldlp	3
	ldlp	10
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	-1431655170
	lsum
	stl	3
	ldl	8
	.ldc	-1431655766
	ladd
	stl	4
	ldlp	3
	ldlp	10
	ldlp	5
	call	@_fmul64
	ldlp	5
	ldlp	7
	call	@_refl64
	ldl	9
	stl	0
	.ldc	2
	ldlp	7
	ldlp	5
	call	@_r64op
	ldl	9
	stl	0
	.ldc	0
	ldlp	5
	ldlp	18
	call	@_r64op
L20:	ldl	12
	cj	@L22
	ldlp	18
	stl	0
	.ldc	1
	ldl	20
	ldnlp	14
	ldlp	10
	call	@_r64op
	ldl	10
	stl	18
	ldl	11
	stl	19
L22:	ldlp	18
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(21)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
