/*
 *	start.c
 *
 *	Handle initialization prior to calling "main".
 *
 *	Copyright 1987, 1988, 1989 by Logical Systems.
 *
 *	WARNING:  THE "_main" ROUTINE NEEDS MODIFICATION FOR USE WITH THE
 *	"static link" GLOBAL DATA MODEL (IT MUST SETUP THE INITIAL VALUE)!
 */

#pragma	asm
	.ext	main			;Main program entry point
	.ext	_arg_get		;Get argv table and args
	.ext	_arg_size		;Get size of argv table and args
	.ext	_boot_chan_in		;Input boot channel address
	.ext	_boot_chan_out		;Output boot channel address
	.ext	exit			;Exit routine
	.ext	_node_number		;User supplied network node #
#pragma	endasm

/*
 *	_main
 *
 *	MUST BE MODIFIED FOR USE WITH THE STATIC LINK DATA MODEL (THE INITIAL
 *	VALUE OF THE STATIC LINK MUST BE SET AND THE DATA ACCESSES MUST BE
 *	CHANGED FROM ".ldc" TO THE APPROPRIATE TECHNIQUE).
 */
_main()
	{
#pragma	asm
	ajw	-2			;A bit of temp space
;
;	At this point WS(1) is the user supplied node #.
;
;	Input channel address is initially in "C"
;
	or
	stl	0			;Input channel address in "A"
	stl	0			;Save for a bit
	ldl	0
	.ldc	_boot_chan_in
	stnl	0			;Save input address
	.ldc	4
	bcnt				;Areg will be 8 for T2, 16 for T4/T8
	ldl	0			;Get input channel address
	xor				;Compute output channel address
	.ldc	_boot_chan_out
	stnl	0			;Save output address
	ldl	1			;Processor node #
	.ldc	_node_number
	stnl	0			;Save processor node #
	ldl	1
	eqc	1			;If node #1, get argv/argc stuff
	cj	@main1			;Jump if not
	call	@_arg_size		;Get needed size of argv table and args
	.ldc	2
	bcnt
	diff				;Since we already have two words...
	ldlp	0			;Point to current WS
	rev
	diff				;Compute new WS
	gajw			
	ldlp	0			;Current WS
	call	@_arg_get		;Get argv vector and arguments
	.ldc	0
	rev				;B is NULL env ptr, A is argc
	ldlp	0
	rev				;C is env ptr, B is argv, A is argc
	call	@main			;Call user program
	j	@main2			;Default to non error exit
main1
	ldlp	1
	stl	0			;argv[0] value
	.ldc	0
	stl	1			;argv[0] points to this
	.ldc	0			;Environment pointer
	ldlp	0			;ARGV
	.ldc	1			;ARGC
	call	@main
main2
	.ldc	0
	call	@exit			;Default to non error exit
#pragma	endasm
	}
