/*
 *	perror - Print error message to standard error.
 *	strerror - Map error number to descriptive string.
 *
 *	Copyright 1987 by Logical Systems
 */

#include	<stdio.h>
#include	<string.h>

void
perror(s)
	const	char	*s;
	{
	if((s != NULL) && (*s != '\0'))
		fprintf(stderr, "%s: ",s);
	fprintf(stderr, "%s\n", strerror(errno));
	}

char	*
strerror(errnum)
	int	errnum;
	{
	extern	int	errno;

	switch(errnum)
		{
		case	0:
			return("No error");
		case	EDOM:
			return("Domain error");
		case	ERANGE:
			return("Range error");
		case	SIG_ERR:
			return("'signal' error");
		default:
			return("Unknown error number");
		}
	}
