/*
 *	File:	timefmt.c
 *
 *	Time/data conversion and formatting routines, includes:
 *
 *	"asctime" & "ctime"
 *
 *	Copyright 1988 by Logical Systems.
 */

#include	<time.h>

/*
 *	Convert broken down time into ASCII string.
 */
char	*
asctime(register const struct tm *timeptr)
	{
	static	char		wday_name[7][3] =
		{
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
		};
	static char		mon_name[12][3] =
		{
		"Jan", "Feb", "Mar", "Apr", "May", "Jun",
		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
		};
	static char		result[26];

	(void) sprintf(result, "%.3s %.3s%3d %.2d:%.2d:%.2d %d\n",
		wday_name[timeptr->tm_wday],
		mon_name[timeptr->tm_mon],
		timeptr->tm_mday, timeptr->tm_hour,
		timeptr->tm_min, timeptr->tm_sec,
		1900 + timeptr->tm_year);
	return (result);
	}

/*
 *	Convert local time into ASCII string.
 */
char	*
ctime(const time_t *timep)
	{
	return asctime(localtime(timep));
	}
