/*
 *	uprint.c
 *
 *	"stripped" printf.
 *
 *	Copyright 1987-1988 by Logical Systems.
 */

#include	<stdio.h>


#define	TRUE	1
#define	FALSE	0

/* Short version of printf to save space */
void
_printf(char *arg, ...)
	{
	register char **argp, *fmt;
	register c, base;
	char s[80], *_itob();

	argp = &arg;

	fmt = *argp;
	while (c = *fmt++) {
		if (c != '%') {
			putchar(c);
			continue;
			}
		while(*fmt >= '0' && *fmt <= '9')
			fmt++;
		switch (c = *fmt++) {
		case 'l':
			switch(c = *fmt++) {
			case 'd':
				base = -10;
				goto prt;
			case 'o':
				base = 8;
				goto prt;
			case 'u':
				base = 10;
				goto prt;
			case 'x':
				base = 16;
				goto prt;
			default:
				putchar(c);
				continue;
			}

		case 'c':
			putchar((int) (*++argp));
			continue;
		case 'd':
			base = -10;
			goto prt;
		case 'o':
			base = 8;
			goto prt;
		case 'u':
			base = 10;
			goto prt;
		case 'x':
			base = 16;
		prt:
			fputs(_itob(*++argp, s, base),stdout);
			continue;
		case 's':
			fputs(*++argp,stdout);
			continue;
		default:
			putchar(c);
			continue;
			}
		}
	}


/* convert an integer to a string in any base (2-36) */
char	*
_itob(n, s, base)
	char *s;
	{
	register unsigned int u;
	register char *p, *q;
	register negative, c;

	if (n < 0 && base == -10) {
		negative = TRUE;
		u = -n;
		}
	else {
		negative = FALSE;
		u = n;
		}
	if (base == -10)	/* signals signed conversion */
		base = 10;
	p = q = s;
	do {			/* generate digits in reverse order */
		if ((*p = u % base + '0') > '9')
			*p += ('A' - ('9' + 1));
		++p;
		} while ((u /= base) > 0);
	if (negative)
		*p++ = '-';
	*p = '\0';		/* terminate the string */
	while (q < --p) {	/* reverse the digits */
		c = *q;
		*q++ = *p;
		*p = c;
		}
	return s;
	}
