/************************************************************************/
/*									*/
/*	File:	tasmdef.h						*/
/*									*/
/*	Definitions for the Transputer Assembler (TASM).		*/
/*									*/
/*		Written by Kirk Bailey of Logical Systems.		*/
/*									*/
/*		Copyright (c) 1986-1987 by Logical Systems.		*/
/*									*/
/*				09/01/86				*/
/*									*/
/************************************************************************/

#define	ACCDATASIZE	1024		/* Data accumulation buffer size */

#define	TEMP_NAME1	".1"		/* Temporary file extension #1 */
#define	TEMP_NAME2	".2"		/* Temporary file extension #2 */

#define	SYMTABSIZE	4096		/* # items TASM sym. tbl. (see next) */
#define	SYMTABMASK	0x0FFF		/* Log base 2 of "SYMTABSIZE" */

#define	FPENTRY		0xAB		/* FPU microcode "sequence" instr. */
#define	FPENTRYSIZE	2		/* Length of "fpentry" instruction */

/************************************************************************/
/*									*/
/*		TASM Internal Mnemonic Definitions			*/
/*									*/
/************************************************************************/

/*
 *	The possible values for the "error #" subfield in T_RESERVED type
 *	records (errors to be put on the listing, recorded on the temp files).
 */

#define	ERR_DUPL	'D'		/* Duplicate definition error */
#define	ERR_EXPR	'E'		/* Expression error */
#define	ERR_FLOAT	'F'		/* Floating point error */
#define	ERR_NOTI	'N'		/* Not implemented opcode/pseudo-op */
#define	ERR_CODE	'O'		/* Unknown opcode/pseudo-op */
#define	ERR_UDEF	'U'		/* Undefined symbol */

/*
 *	Symbolic optimization levels.
 */
#define	OLOW		0		/* No prefix optimization */
#define	OMED		1		/* Fix boundary cases  */
#define	OHIGH		2		/* Defer boundary cases */
