/************************************************************************/
/*									*/
/*	File:	tlnktyp.h						*/
/*									*/
/*	Data type declarations for the Transputer Linker (TLNK).	*/
/*									*/
/*		Written by Kirk Bailey of Logical Systems.		*/
/*									*/
/*		Copyright (c) 1986-1987 by Logical Systems.		*/
/*									*/
/*				09/01/86				*/
/*									*/
/************************************************************************/

#if	VMFILE
struct	vbuf				/* Virtual memory buffer unit */
	{
	struct	vbuf	*next;		/* Point to next "vbuf" in file */
	int	vcount;			/* Bytes in this buffer */
	UCHAR	vbuffer[VBSIZE];	/* Actual characters in buffer */
	};

struct	vstream				/* Virtual memory "stream" ptr info */
	{
	struct	vbuf	*first;		/* First "vbuf" of file */
	struct	vbuf	*current;	/* Current "vbuf" of file */
	};
#endif	/* VMFILE */

struct	gst				/* Global symbol table element */
	{
	UINT	lst_num;		/* Definition local symbol # */
	STRING	name;			/* Point to ASCII symbol name */
	};

struct	lbuf				/* Local buffer control structure */
	{
	unsigned char	*start;		/* Pointer to start of buffer */
	int	count;			/* # of chars in buffer */
	VSTREAM	fp;			/* File pointer for buffer */
	unsigned char	*ptr;		/* Current buffer pointer */
	};

struct	lst				/* Local symbol table element */
	{
	UINT	gst_num;		/* Global symbol table # (if needed) */
	SLONG	max_addr;		/* Maximum definition address */
	SLONG	min_addr;		/* Minimum definition address */
	UINT	region;			/* Code/data region tag */
	};
