/*
 *	TCX Compiler (8 of 11)
 *
 *	Copyright 1987-1988 by Quality Computer Systems and Logical Systems.
 *	All rights reserved.
 *
 *	Published by:	Logical Systems
 *			P.O. Box 1702
 *			Corvallis, OR 97339 (USA)
 *
 *	03/17/87
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "tcx.h"
#include "tcxdecl.h"

#if	((H_OPSYS != MPW) && (H_OPSYS != BSD4_2) && (H_OPSYS != XENIX))
#include <stdlib.h>
#include <stddef.h>
#endif	/* !MPW && !BSD4_2 && !XENIX */

PRIVATE	char	*mptr	=	NULL;	/* Input line pointer */

/*
 *	This section handles I/O and preprocessor commands.
 */

/*
 *	Get the next input file.
 */
PUBLIC	VOID
getinfil()
	{
	extern	VOID		cantop();
	extern	VOID		getfilename();
	extern	LABEL		getlabel();
	extern	int		new_name_space();

	if(Ninfils--)
		{			/* Any more input files? */
		getfilename(*Nextfil++,Infil,"pp");	/* Default PP file */
		if((Input = fopen(Infil, "r")) == NULL)
			cantop(Infil);
		Lineno = 0;
		Newfile = TRUE;
		(VOID) new_name_space(FALSE);	/* Rewind member name space */
		if(Verbose)
			fprintf(STDERR,"*** Read    %s\n",Infil);
		}
	else
		Eof = TRUE;
	}

/*
 *	Open code output and temporary files.
 */
PUBLIC	VOID
getoutfil()
	{
	extern	VOID		cantop();
	extern	char		*getenv();
	extern	VOID		header();
	extern	char		*strrchr();

	char			*cptr;
	int			i;
/*
 *	Open inter-pass temp file if required.
 */
	if(Inter_file)
		{
		Ipfil[0] = '\0';
		if((cptr = getenv(TEMP_PATH)) != NULL)
			{
			if(strlen(cptr) < FILNAMSIZE)
				strcpy(Ipfil,cptr);
			}
/*
 *	Ensure temp directory has trailing delimiter and prune directory name
 *	from input file.
 */
#if	H_OPSYS == MPW
		if(((i = strlen(Ipfil)) > 0) && (Ipfil[i - 1] != ':'))
			strcat(Ipfil,":");
		if((cptr = strrchr(Infil,':')) == NULL)
#else	/* !MPW */
		if(((i = strlen(Ipfil)) > 0) && (Ipfil[i - 1] != '/') &&
			(Ipfil[i - 1] != '\\'))
			{
			strcat(Ipfil,"/");
			}
		if(((cptr = strrchr(Infil,'/')) == NULL) &&
			((cptr = strrchr(Infil,'\\')) == NULL))
#endif	/* MPW */
			{
			cptr = &Infil[-1];
			}
/*
 *	Add input filename to any existing temp directory path.
 */
		if((strlen(Ipfil) + strlen(++cptr)) < FILNAMSIZE)
			strcat(Ipfil,cptr);
		else
			strcpy(Ipfil,cptr);
/*
 *	Prune the filename extension from the temp version of the input file
 *	and substitute the temp file version.
 */
		if((cptr = strrchr(Ipfil,'.')) != NULL)
			*cptr = '\0';
		if((strlen(Ipfil) + strlen(TEMP_NAME)) < FILNAMSIZE)
			strcat(Ipfil,TEMP_NAME);
		else
			strcpy(Ipfil,TEMP_NAME);
#if	CRLF
		if((Interfp = fopen(Ipfil,"w+b")) == NULL)
#else	/* !CRLF */
		if((Interfp = fopen(Ipfil,"w+")) == NULL)
#endif	/* CRLF */
			cantop(Ipfil);
		}
/*
 *	Open output file.
 */
	if((Coutput = fopen(Coutfil, "w")) == NULL)
		cantop(Coutfil);
	header();
	}

/*
 *	Flush the output file.
 */
PUBLIC	VOID
flushout()
	{
	extern	struct	dvrt	*dvrt_get();
	extern	VOID		dvrt_out();
	extern	VOID		trailer();

	trailer();
	dvrt_out(dvrt_get());		/* Write current diversion out */
	}

/*
 *	Close the code output and temporary files.
 */
PUBLIC	VOID
closeout()
	{
	extern	VOID		fatal();
	extern	int		unlink();

	if(fclose(Coutput) == EOF)
		fatal("Can't close output file");
	
	if(Inter_file)
		{
		if(fclose(Interfp) == EOF)
			fatal("Can't close temporary file");
		if(unlink(Ipfil) == -1)
			fatal("Can't remove temporary file");
		}
	}

/*
 *	Remove output file.
 */
PUBLIC	VOID
deleteout()
	{
	extern	VOID		fatal();
	extern	int		unlink();

	if(unlink(Coutfil) == -1)
		fatal("Can't remove output file");
	}

/*
 *	Get file name, optionally append extension.
 */
PUBLIC	VOID
getfilename(s,name,ext)
	char			*s;
	char			*name;
	char			*ext;
	{
	extern	char		*strchr();
	extern	char		*strrchr();

	register	int	i;
	register	char	*p;

	p = name;
	i = 0;
/*
 *	Following loop also terminates on trailing " of a string constant.
 */
	while(*s && (*s != '\"') && (++i <= FILNAMSIZE))
		*p++ = *s++;
	*p = '\0';
#if	H_OPSYS == VMS
/*
 *	Later - should use VMS filename parsing routines.
 */
	if((strrchr(name,';') == NULL) &&
/*
 *	Don't add .ext if has ;version.
 */
 		(strchr(((strrchr(name,']') == NULL) ? name :
/*
 *	Ignore '.' in directory names.
 */
			strrchr(name,']')),'.') == NULL)
		&& (++i < FILNAMSIZE))
#endif
#if	((H_OPSYS == UNIX) || (H_OPSYS == BSD4_2) || (H_OPSYS == XENIX))
	if((strchr(((strrchr(name,'/') == NULL) ? name : strrchr(name,'/')),
		'.') == NULL)		/* Ignore '.' in directory names */
		&& (++i < FILNAMSIZE))
#endif
#if	H_OPSYS == MPW
	if((strchr(((strrchr(name,':') == NULL) ? name : strrchr(name,':')),
		'.') == NULL)		/* Ignore '.' in directory names */
		&& (++i < FILNAMSIZE))
#endif
#if	H_OPSYS == MS_DOS
	if((strchr(((strrchr(name,'\\') == NULL) ? name : strrchr(name,'\\')),
		'.') == NULL)		/* Ignore '.' in directory names */
		&& (++i < FILNAMSIZE))
#endif
/*
 *	`{' placed here to allow VI's brace-match function to work.
 */
		{
		*p++ =	'.';		/* No extension given */
		while((*ext != '\0') && (++i <= FILNAMSIZE))
			*p++ = *ext++;
		*p = '\0';
		}
	}

PRIVATE	VOID
cantop(filename)
	char			*filename;
	{
	fprintf(STDERR,"Can't open: %s\n",filename);
	exit(BADEXIT);
	}

/*
 *	Get the next line of input.
 */
PUBLIC	VOID
inline()
	{
	extern	VOID		error();
	extern	VOID		getinfil();
	extern	VOID		kill_line();
	register	int	c;

	for(;;)
		{			/* Find a non-empty line or EOF */
		if(Eof)
			return;
		kill_line();		/* Clear the input line */
		++Lineno;
		while((c = getc(Input)) != EOF)
			{
			if(c == '\n')
				break;
			else if((Lptr - Line) >= LINEMAX)
				{
				error("Input line too long");
				break;
				}
			else
				*Lptr++ = c;
			}
		*Lptr = '\0';
		if(Lptr != Line)	/* Anything on this line? */
			{
			Lptr = Line;	/* Reset line to beginning */
			return;
			}
		else if(c == EOF)
			{
			fclose(Input);
			getinfil();	/* Get the next input file */
			}
		}
	}

PUBLIC	VOID
outline(opcode,operand,comment)
	int			opcode;
	register	char	*operand;
	register	char	*comment;
	{
	extern	VOID		dvrt_write();
	extern	VOID		lineline();

	lineline();
/*
 *	Write opcode.
 */
	dvrt_write(opcode);
/*
 *	Write operand field.
 */
	if(operand != NULL)
		{
		while(*operand)
			dvrt_write((int) *operand++);
		}
	dvrt_write('\0');
/*
 *	Write comment field.
 */
	if(comment != NULL)
		{
		while(*comment)
			dvrt_write((int) *comment++);
		}
	dvrt_write('\0');
	}

PUBLIC	VOID
mem_err()
	{
	extern	VOID		fatal();

	fatal("Out of memory");
	}

/*
 *	Output a "#line" line if desirable.
 */
PUBLIC	VOID
lineline()
	{
	extern	VOID		outcomment();

	static	int		lastline;
	char			buffer[80];

	if(Source_info && (Newfile || (Lineno != lastline)))
		{
		if(Newfile)
			sprintf(buffer,"#line\t%d\t\"%s\"",Lineno,Infil);
		else
			sprintf(buffer,"#line\t%d",Lineno);
		lastline = Lineno;
		Newfile = FALSE;
		outcomment(buffer);
		}
	}

/*
 *	assign
 *
 *	Write a .VAL pseudo-op.
 */
PUBLIC	VOID
assign(name,oldname,plus,offset)
	char			*name;	/* Name of the symbol	*/
	char			*oldname;	/* Used if in another sym */
	int			plus;	/* TRUE if adding symbols */
	INT32			offset;	/* Value to set	*/
	{
	extern	VOID		out_line();

	char			buf[LINESIZE];

	sprintf(buf,"%s,%s%s%ld",name,((oldname != NULL) ? oldname : ""),
		((oldname != NULL) ? ((plus) ? "+" : "-") : ""),
		(long) offset);
	outline(TOP_VAL,buf,NULL);
	}

/*
 *	Print an erroneous line with a pointer (^) to the location where the
 *	error was discovered and a message describing the error.
 */
PUBLIC	VOID
error(mesg)
	char			*mesg;
	{
	extern	VOID		errfile();
	extern	VOID		errptr();

	errfile();
	fprintf(STDERR,"%s\n",mesg);
	errptr();
	}

/*
 *	Print an erroneous line with a pointer (^) to the location where the
 *	warning was discovered and a message describing the warning.
 */
PUBLIC	VOID
warning(level,mesg)
	int			level;
	char			*mesg;
	{
	extern	VOID		warnfile();
	extern	VOID		errptr();

	if(level <= Warn_level)
		{
		warnfile();
		fprintf(STDERR,"%s\n",mesg);
		errptr();
		}
	}

/*
 *	Print an erroneous line with a pointer (^) to the location where the
 *	warning was discovered and a message describing the warning.
 */
PUBLIC	VOID
warnname(level,mesg,name)
	int			level;
	char			*mesg;
	char			*name;
	{
	extern	VOID		warnfile();
	extern	VOID		errptr();

	if(level <= Warn_level)
		{
		warnfile();
		fprintf(STDERR,"%s: %s\n",mesg,name);
		errptr();
		}
	}

PUBLIC	VOID
fatal(mesg)
	char			*mesg;
	{
	extern	VOID		errfile();
	extern	VOID		errptr();

	errfile();
	fprintf(STDERR,"%s\n",mesg);
	exit(BADEXIT);
	}

/*
 *	"not-yet-implemented message generator.
 */
PUBLIC	VOID
notyet(mesg)
	char			*mesg;
	{
	extern	VOID		errfile();
	extern	VOID		errptr();

	errfile();
	fprintf(STDERR,"%s - not yet implemented\n",mesg);
	errptr();
	}

/*
 *	Print error message.
 */
PUBLIC	VOID
errname(mesg,name)
	char			*mesg;
	char			*name;
	{
	extern	VOID		errfile();
	extern	VOID		errptr();

	errfile();
	fprintf(STDERR,"%s: %s\n",mesg,name);
	errptr();
	}

/*
 *	Print the name of the file which contains the error.
 */
PRIVATE	VOID
errfile()
	{
	++Errcnt;
	fprintf(STDERR,"<%s> @ %d: ",Infil,Lineno);
	}

/*
 *	Print the name of the file which contains the warning.
 */
PRIVATE	VOID
warnfile()
	{
	fprintf(STDERR,"<%s> @ %d: WARNING: ",Infil,Lineno);
	}

/*
 *	Print the input line with a pointer (^) under the error.
 */
PRIVATE	VOID
errptr()
	{
	register	char	*p;

	p = Line;
	if(*p != '\0')
		{
		fprintf(STDERR,"%s\n",p);	/* Print erroneous line */
		while(p < Lptr)
			{		/* Get to error location */
/*lint -e516 Does ANSI know what it is doing? */
	    putc(((*p++ == '\t') ? '\t': ' '),STDERR);
/*lint +e516 */
			}
		fprintf(STDERR,"^\n");		/* Print error pointer ^ */
		}
	}

/*
 *	Common error routines.
 */

PUBLIC	INT32
f_to_l(f,msg)
	double			f;
	BOOL			msg;
	{
	extern	VOID		error();
/*
 *	Note that the following test is not perfect since ideally you should
 *	allow floating point constants of > 2**31-1 to convert to unsigned
 *	integers.  This is not done since several of the "C" compilers which
 *	are used to host TCX don't handle this very well (everyone gets tired
 *	of exception traps eventually...).  TCX internally handles this
 *	correctly, now if we could just get a few other folks to fix their
 *	code generators... (Microsoft et. al. are you listening?)
 */
	if((f < (double) ((INT32) MIN_LONG_32B)) ||
		(f > (double) ((INT32) MAX_LONG_32B)))
		{
		if(msg)
			{
		error("Floating point number out of signed integral range");
			}
		return ((INT32) 0);
		}
	return ((INT32) f);
	}

PUBLIC	VOID
scerr()
	{
	extern	VOID		error();

	error("Invalid storage class");
	}

PUBLIC	VOID
typerr()
	{
	extern	VOID		error();

	error("Invalid type");
	}

PUBLIC	VOID
illname()
	{
	extern	VOID		error();
	extern	VOID		junk();

	error("Illegal symbol name");
	junk();
	}

PUBLIC	VOID
multidef(name)
	char			*name;
	{
	extern	VOID		errname();

	errname("Already defined",name);
	}

PUBLIC	VOID
redefmem(name)
	char			*name;
	{
	extern	VOID		errname();

	errname("Redefinition of structure/union member",name);
	}

PUBLIC	VOID
tagerr(tag)
	char			*tag;
	{
	extern	VOID		errname();

	errname("Undeclared tag",tag);
	}

PUBLIC	VOID
needpunc(c)
	int			c;
	{
	extern	VOID		errname();
	extern	BOOL		matchc();

	static	char		s[2];

	s[1] = '\0';
	if(! matchc((int) (s[0] = c)))
		errname("Missing punctuation -- assumed present",s);
	}

PUBLIC	VOID
keyerr(keyword)
	char			*keyword;
	{
	extern	VOID		errname();

	errname("Illegal use of a keyword",keyword);
	}

PUBLIC	VOID
sizerr()
	{
	extern	VOID		error();

	error("Need explicit array size");
	}

PUBLIC	VOID
initerr()
	{
	extern	VOID		error();

	error("Initializer must be constant expression");
	}

PUBLIC	VOID
cexperr()
	{
	extern	VOID		error();

	error("Must be constant expression");
	}

/*
 *	Test parse line to see if lit matches the next sequence of characters
 *	and skip over them if it does.
 */
PUBLIC	BOOL
match(lit)
	char			*lit;
	{
	extern	VOID		blanks();
	extern	int		streq();
	register	int	k;

	blanks();			/* Skip white space */
	if(k = streq(Lptr,lit))
		{
		Lptr += k;
		return (TRUE);
		}
	return (FALSE);
	}

/*
 *	Test parse line to see if c matches the next character and skip it.
 */
PUBLIC	BOOL
matchc(c)
	int			c;
	{
	extern	VOID		blanks();

	blanks();			/* Skip white space */
	if(*Lptr == c)
		{
		++Lptr;
		return (TRUE);
		}
	return (FALSE);
	}

/*
 *	Test parse line to see if 'c' is the next char.
 */
PUBLIC	BOOL
nextc(c)
	int			c;
	{
	extern	VOID		blanks();

	blanks();
	return (*Lptr == c);
	}

/*
 *	Test parse line to see if lit matches the next token and skip over it
 *	if a match is found.
 */
PUBLIC	BOOL
amatch(lit)
	char			*lit;
	{
	extern	BOOL		chks();
	extern	VOID		blanks();
	extern	VOID		skip();

	blanks();
	if(chks(lit))
		{
		skip();
		return (TRUE);
		}
	return (FALSE);
	}

/*
 *	Skip white space in parse line.
 */
PUBLIC	VOID
blanks()
	{
	extern	int		ch();
	extern	int		gch();
	extern	VOID		inline();
	extern	VOID		preprocess();

	register	int	c;

	for(;;)
		{
		while((c = ch()) == '\0')
			{		/* At eol? */
			if(Stopeol)
				return;	/* OK to pass eol? */
			inline();	/* Get next line */
			if(Eof)
				return;
			preprocess();
			}

		if(isspace(c))
			(VOID) gch();
		else
			return;
		}
	}

/*
 *	Match string against next token in parsing buffer.
 */
PUBLIC	BOOL
chks(s)
	char			*s;
	{
	extern	int		astreq();

	return (astreq(Lptr, s, (int) strlen(s)));
	}

/*
 *	Test two strings for equality up to the end of the second string.
 */
PUBLIC	int
streq(s1,s2)
	char			*s1;
	char			*s2;
	{
	register	int	len;

	len = 0;
	while(*s2)
		{
		if(*s1++ != *s2++)
			return (0);
		++len;
		}
	return (len);
	}

/*
 *	Test two strings for equality of contents up to len (signed int).
 */
PRIVATE	int
astreq(s1,s2,len)
	char			*s1;
	char			*s2;
	int			len;
	{
	extern	BOOL		issym();

	register	int	cnt;

	for(cnt = 0; cnt < len; ++cnt)
		{
		if(*s2 == '\0')
			break;
		if(*s1++ != *s2++)
			return (0);
		}
	return ((issym(*s1)) ? 0 : cnt);
	}

/*
 *	Skip token in input line.
 */
PUBLIC	VOID
skip()
	{
	extern	BOOL		issym();

	while(issym(*Lptr))
		++Lptr;			/* Skip all a/n chars */
	}

/*
 *	Throw away garbage in input line.
 */
PUBLIC	VOID
junk()
	{
	extern	VOID		blanks();
	extern	BOOL		chkeyword();
	extern	BOOL		endst();
	extern	VOID		inline();
	extern	BOOL		issym();
	extern	int		ch();
	extern	int		gch();

	static	char		*lastlptr = NULL;

	if(Lptr == lastlptr)
		{
		if(ch() == '\0')
			{
			Stopeol = FALSE;
			blanks();
			}
		else
			(VOID) gch();
		}

	while((! issym(ch())) || (! chkeyword()))
		{
		if(endst() || (ch() == '}'))
			break;		/* Up to EOL or ';' or '}' */
		(VOID) gch();		/* Flush non-a/n characters */
		}

	lastlptr = Lptr;
	}

/*
 *	Is 'c' valid as the first character in a C symbol?
 */
PUBLIC	BOOL
issymf(c)
	register	int	c;
	{
	return (isalpha(c) || c == '_');
	}

/*
 *	Is 'c' valid as any but the first character in a C symbol?
 */
PUBLIC	BOOL
issym(c)
	register	int	c;
	{
#if	H_OPSYS == VMS
	return (isalpha(c) || isdigit(c) || c == '_' || c == '$');
#else	/* H_OPSYS != VMS */
	return (isalpha(c) || isdigit(c) || c == '_');
#endif	/* H_OPSYS == VMS */
	}

/*
 *	Test for end of statement.
 */
PUBLIC	BOOL
endst()
	{
	extern	int		ch();

	blanks();			/* Skip white space */
	return ((ch() == ';') || (ch() == '\0'));
	}

/*
 *	Look at current character in parsing buffer.
 */
PUBLIC	int
ch()
	{
	return ((int) *Lptr);
	}

/*
 *	Look at next character in parsing buffer.
 */
PUBLIC	int
nch()
	{
	return (*Lptr ? *(Lptr+1) : 0);
	}

/*
 *	Get current character in parsing buffer.
 */
PUBLIC	int
gch()
	{
	return (*Lptr ? *Lptr++ : 0);
	}

/*
 *	Put a character back in the parsing buffer.
 */
PUBLIC	VOID
putback(c)
	{
	extern	VOID		fatal();

	unsigned	int	length;
	register	char	*ptr1;
	register	char	*ptr2;

	if(Lptr > Line)
		*--Lptr = c;
	else
		{
		if((length = strlen(Line)) < LINEMAX)
			{
			ptr2 = &Line[length];
			ptr1 = ptr2 + 1;
			while(ptr1 != &Line[0])
				*ptr1-- = *ptr2--;
			Line[0] = c;
			}
		else
			fatal("Compiler error: putback");
		}
	}

/*
 *	Clear current line from parsing buffer.
 */
PUBLIC	VOID
kill_line()
	{
	Lptr = Line;
	*Lptr = '\0';
	}

/*
 *	Check for #preprocessor commands.
 */
PRIVATE	VOID
preprocess()
	{
	extern	int		ch();
	extern	VOID		doasm();
	extern	VOID		error();
	extern	BOOL		matchc();
	extern	VOID		ppcline();

	if(! matchc('#'))
		{			/* If it's not a #command... */
		Lptr = Line;		/* Start at beginning of line */
		ppcline();		/* Process the input line */
		}
	else
		{			/* Do a #preprocessor command */
		Stopeol = TRUE; 	/* Look only on this line */
		if(amatch("asm"))
			doasm();	/* Copy assembler thru */
		else if(amatch("line"))
			{
			ppcline();	/* Strip comments */
			blanks();
			if(! isdigit(ch()))	/* New line number? */
				error("#line number must be decimal");
			else
				{
				Lineno = 0;
				Newfile = TRUE;	/* Emit an entire line */
				while(isdigit(ch()))
					Lineno = 10 * Lineno + gch() - '0';
				--Lineno;	/* Adjust for next line */
				skip();
				if(! endst())	/* Optional filename? */
					{
					if(matchc('\"'))
						getfilename(Lptr,Infil,"pp");
					else
						error("Illegal #line format");
					}
				}
			}
		else
			error("Unknown #preprocessor command");
		Stopeol = FALSE;	/* Don't stop at end-of-line */
		kill_line();
		}
	}

/*
 *	Preprocess the "C" input line.
 */
PRIVATE	VOID
ppcline()
	{
	extern	VOID		blanks();
	extern	int		ch();
	extern	VOID		error();
	extern	BOOL		issym();
	extern	BOOL		issymf();
	extern	VOID		keepch();

	register int		c;
	register char		*savelptr;

	mptr = savelptr = Lptr;		/* Remember where we are on the line */
	while(c = ch())
		{
		if(c == ' ' || c == '\t')
			{		/* Eliminate excess whitespace */
			keepch(' ');
			while((ch() == ' ') || (ch() == '\t'))
				(VOID) gch();
			}
		else
			{
			blanks();
			if(issymf(c))
				{		/* Is it a symbol? */
				while(issym(ch()))
					keepch(gch());	/* Keep text */
				}
			else if((c == '/') && (*(Lptr+1) == '*'))
				{
				(VOID) gch();
				(VOID) gch();	/* Discard comments */
				while((*Lptr != '*') || (*(Lptr+1) != '/'))
					{
					if(gch() == 0)	/* If EOL get */
						inline();	 /* nxt line */
					if(Eof)
						{
						error("Unclosed comment");
						break;
						}
					}
				(VOID) gch();
				(VOID) gch();	/* Toss comment end */
				}
			else if(c == '\"')
				{
/* Pass string through */	keepch(gch());
/* Unchanged */			while(ch() != '\"')
					{
					if(ch() == 0)
						{
/* Backup and use last cell again */		--mptr;
						error("Missing quote");
						break;
						}
					if(ch() == '\\')
/* Pass an escape character */			{
						if(nch())	/* not EOL */
							keepch(gch());
						else
/* More long lines */					{
							inline();
							continue;
							}
						}
					keepch(gch());
					}
				(VOID) gch();
				keepch('\"');
				}
			else if(c == '\'')
				{
/* Pass char constants */	keepch(gch());
/* Unchanged */			while(ch() != '\'')
					{
					if(ch() == 0)
						{
/* Backup and use last cell again */		--mptr;
						error("Missing apostrophe");
						break;
						}
/* Pass escape character */			if(ch() == '\\')
						keepch(gch());
					keepch(gch());
					}
				(VOID) gch();
				keepch('\'');
				}
			else
				keepch(gch());	/* Pass all else unchanged */
			}
		}
	*mptr = '\0';
	Lptr = savelptr;		/* Restore original position */
	}

/*
 *	Put a char in input buffer
 */
PRIVATE	VOID
keepch(c)
	{
	*mptr++ = c;
	}

/*
 *	Maximum length checked "strcat".  Returns updated pointer.
 */
PUBLIC	char	*
safecat(cur,str,end)
	register char		*cur;
	register char		*str;
	register char		*end;
	{
	while((cur < end) && (*str != '\0'))
		*cur++ = *str++;
	return (cur);
	}

/*
 *	Like "safecat" but appends the string equivalent of an INT32.
 */
PUBLIC	char	*
safedec(cur,num,end)
	char			*cur;
	INT32			num;
	char			*end;
	{
	extern	char		*safecat();

	char			longbuf[80];

	sprintf(longbuf,"%ld",(long) num);
	return (safecat(cur,longbuf,end));
	}

/*
 *	Like "safecat" but appends the string equivalent of an double.
 */
PUBLIC	char	*
safefloat(cur,num,end)
	char			*cur;
	double			num;
	char			*end;
	{
	extern	char		*safecat();

	char			floatbuf[80];

	sprintf(floatbuf, "%.20g", num);
	return (safecat(cur,floatbuf,end));
	}

/*
 *	Convert signed or unsigned integral constant into floating point.
 *	Input is a pointer to the "constant" non-terminal leaf node which
 *	points to the terminal holding the actual constant.
 */
PUBLIC	double
l_to_f(constant)
	struct	op_node		*constant;
	{
	if(constant->right.ptr.terminal->type & SIGNED_NODE)
		return ((double) constant->right.ptr.terminal->val.integral);
	else
		return ((double) constant->right.ptr.terminal->val.uintegral);
	}

PUBLIC	VOID
outcomment(str1)
	char			*str1;
	{
	extern	VOID		out_line();
	
	outline(TOP_COMMENT,NULL,str1);
	}

PUBLIC	VOID
instruction(opcode,absrel,symone,symtwo,offset,comment)
	int			opcode;
	char			*symone;
	char			*symtwo;
	int			absrel;
	INT32			offset;
	char			*comment;
	{
	extern	VOID		out_line();
	extern	char		*safecat();
	extern	char		*safedec();

	char			cbuf[NAMEMAX];
	char			buf[LINESIZE];
	char			*cur;
	char			*end;

	cur = buf;
	end = buf + (sizeof(buf) - 1);

	if((symone != NULL) || (symtwo != NULL) || (offset != 0))
		{
		if(symone != NULL)
			{
			if(absrel == REL)
				cur = safecat(cur,"@",end);
			cur = safecat(cur,symone,end);
			}
		if(symtwo != NULL)
			{
			cur = safecat(cur,"-",end);
			if(absrel == REL)
				cur = safecat(cur,"@",end);
			cur = safecat(cur,symtwo,end);
			}
		if(offset > 0)
			cur = safecat(cur,"+",end);
		if(offset != 0)
			cur = safedec(cur,offset,end);
		}
	else if(absrel != NONE)
		cur = safecat(cur,"0",end);
	*cur = '\0';

	if(comment != NULL)		/* Add comment delimiter to field */
		{
		cur = cbuf;
		end = cbuf + (sizeof(cbuf) - 1);
		cur = safecat(cur,comment,end);
		*cur = '\0';
		comment = cbuf;
		}
	outline(opcode,buf,comment);
	}

/*
 *	Print assembler info before any code is generated.
 */
PUBLIC	VOID
header()
	{
	extern	VOID		instruction();
	extern	VOID		no_oper();
	extern	VOID		outcomment();
	extern	char		*safecat();
	extern	VOID		segment();

	char			buf[80];

	sprintf(buf,";\tCompiled by TCX %s",Version);
	outcomment(buf);

	if(Cpu_type & (T800|T8EX))
		no_oper(TOP_T800);
	else
		{
		if(Cpu_type & (T212|T2EX))
			no_oper(TOP_T212);
		else if(Cpu_type & (T414|T4EX))
			no_oper(TOP_T414);
		else
			no_oper(TOP_ALL);
		no_oper(TOP_EMULATE);
		}
	if(Rel_only)
		no_oper(TOP_REL);
	if(Static_link)
		instruction(TOP_EXT,ABS,SLBNAME,NULL,(INT32) 0,NULL);

	segment(SEG_UNINIT);		/* Default to uninit. data module */
	}

/*
 *	Print any assembler stuff needed after all code.
 */
PUBLIC	VOID
trailer()
	{
	extern	VOID		no_oper();

	no_oper(TOP_END);
	}

/*
 *	"#asm" preprocessor command.
 */
PUBLIC	VOID
doasm()
	{
	extern	BOOL		amatch();
	extern	VOID		dvrt_write();
	extern	VOID		inline();
	extern	VOID		lineline();
	extern	BOOL		matchc();
	extern	VOID		outcomment();
	extern	VOID		ppaline();

	for(;;)
		{
		inline();		/* Get next line */
		if(Eof)
			break;
		if(matchc('#'))
			{
			if(amatch("endasm"))
				break;
			}
/*
 *	Output assembly language line as comment to code generator.
 */
		lineline();		/* Update line # info if needed */
		dvrt_write((int) TOP_COMMENT);	/* Indicate it is a comment */
		dvrt_write('\0');	/* Dummy operand field */
		ppaline();		/* Output asm line in comment field */
		dvrt_write('\0');	/* Terminate comment field */
		}
	}

/*
 *	Preprocess the assembly input line and output the result.
 */
PRIVATE	VOID
ppaline()
	{
	extern	int		ch();
	extern	char		*chksym();
	extern	VOID		errname();
	extern	VOID		dvrt_write();
	extern	VOID		error();
	extern	int		gch();
	extern	struct	id_node	*lookup_node();
	extern	char		*safecat();
	extern	char		*safedec();
	extern	INT32		word();

	register int		c;
	register char		*cptr;
	char			*cur;
	char			*end;
	char			name[NAMEMAX+1];
	INT32			offset;
	int			sc;
	struct	id_node		*sym;

	Lptr = Line;			/* Restart at beginning of line */
	while(c = ch())
		{
		if((c == ' ') || (c == '\t'))
			{		/* Eliminate excess whitespace */
			dvrt_write((int) ' ');
			while((ch() == ' ') || (ch() == '\t'))
				(VOID) gch();
			}
		else if(c == '[')
			{		/* Substitute local variable offsets */
			(VOID) gch();	/* Toss opening bracket */
			cptr = name;
			if(ch() == '?')
				*cptr++ = gch();	/* Allow "?slb" */
			if(((cptr = chksym(cptr)) == NULL) || (*cptr != ']'))
				{
				error("Badly formatted variable name");
				break;
				}
			if((sym = lookup_node(name,NS_VAR)) == NULL)
				{
				errname("Undefined variable",name);
				break;
				}
			sc = sym->info.storage_class;
			if((sc != SC_AUTO) && (sc != SC_ARG) && (sc != SC_REG))
				{
			error("Variable must be argument/auto/register");
				break;
				}
/*
 *	Compute workspace relative expression to access variable.
 */
			cur = name;
			end = name + (sizeof(name) - 1);
			cur = safecat(cur,"(",end);
			cur = safecat(cur,WORKSPACE,end);
			if((offset = -word(-sym->address.offset)) >= 0L)
				cur = safecat(cur,"+",end);
			cur = safedec(cur,offset,end);
			cur = safecat(cur,")",end);
			*cur = '\0';
/*
 *	Substitute for variable name.
 */
			cptr = name;
			while(*cptr)
				dvrt_write((int) *cptr++);
			while(ch() != ']')
				(VOID) gch();	/* Toss local variable name */
			(VOID) gch();	/* Toss trailing ']' */
			}
		else if(c == '\"')
			{		/* Pass strings on through */
			dvrt_write((int) gch());
			while(ch() != '\"')
				{	/* Unchanged */
				if(ch() == 0)
					{
					error("Missing quote");
					break;
					}
				if(ch() == '\\')
					{	 /* Pass an escape char */
					dvrt_write((int) gch());
					}
				if(ch())
					dvrt_write((int) gch());
				}
			if(ch())
				dvrt_write((int) gch());	/* Final " */
			}
		else if(c == '\'')
			{		/* Pass char constants on through */
			dvrt_write((int) gch());
			while(ch() != '\'')
				{	/* Unchanged */
				if(ch() == 0)
					{
					error("Missing apostrophe");
					break;
					}
				if(ch() == '\\')	/* Pass escape char */
					dvrt_write((int) gch());
				if(ch())
					dvrt_write((int) gch());
				}
			if(ch())
				dvrt_write((int) gch());	/* Final ' */
			}
		else if(c == ';')
			{		/* Rest of line is a comment */
			cptr = Lptr;
			while(*cptr)
				dvrt_write((int) *cptr++);
			break;
			}
		else			/* Pass all else unchanged */
			dvrt_write((int) gch());
		}
	}

/*
 *	Load constant value onto top of stack.
 */
PUBLIC	VOID
loadconstant(value)
	INT32			value;
	{
	extern	VOID		abs_oper();

	abs_oper(TOP_LDC,(INT32) value);
	}

/*
 *	Print a global label for a variable or function name.
 */
PUBLIC	VOID
glblabel(name,sc)
	char			*name;
	int			sc;
	{
	extern	VOID		instruction();
	extern	VOID		outline();

	if((sc == SC_GLOBAL) || (sc == SC_EXTERN))
		instruction(TOP_PUB,ABS,name,NULL,(INT32) 0,NULL);
	outline(TOP_LABEL,name,NULL);
	}

/*
 *	Change to specified segment.
 */
PUBLIC	VOID
segment(seg)
	int			seg;
	{
	extern	VOID		abs_oper();

	static	int 		pseg = SEG_NONE;	/* Previous seg */

	if((seg != SEG_NONE) && (seg != pseg) &&
		((pseg == SEG_NONE) || (SegMap[seg] != SegMap[pseg])))
		{
		abs_oper(TOP_MOD,(INT32) SegMap[seg]);
		}
	pseg = seg;
	}

/*
 *	Align assembler's location counter to next word boundary.
 */
PUBLIC	VOID
align()
	{
	extern	VOID		no_oper();

	no_oper(TOP_ALIGN);
	}

/*
 *	Default initialization in a data segment.
 */
PUBLIC	INT32
definit(amt)
	INT32			amt;
	{
	extern	VOID		abs_oper();

	if(amt > 0)
		abs_oper(TOP_DS,(INT32) amt);

	return (amt);
	}

/* End of TCX8.C */
